CREATE PROCEDURE [dbo].[sp_fajl_create] @dokumenTxt text, @path varchar(150), @creUser smallint
AS
BEGIN

BEGIN TRY

	--mappa ellenrzs
	DECLARE @directory nvarchar(150), @mappaIndex int, @result int = 1, @command nvarchar(4000), @proxyAcc varchar(50) = (SELECT TOP 1 LTRIM(RTRIM(ProxyAcc)) FROM CEG ORDER BY CegID)

	IF(@proxyAcc IS NULL OR @proxyAcc = '')
	BEGIN
		SELECT -1 AS hiba, 'Nincs megadva a cg trzsben a Proxy Account' AS hibaszov
		RETURN
	END	

	SET @mappaIndex = CHARINDEX('\', REVERSE(@path), 1)

	IF(@mappaIndex = 0)
	BEGIN
		SELECT -2 AS hiba, 'rvnytelen mappa' AS hibaszov
		RETURN
	END

	SET @directory = LEFT(@path, LEN(@path) - @mappaIndex + 1)

	DELETE FROM TMP_DOC WHERE CreUser = @creUser AND DocPath = @path

	EXECUTE AS USER = @proxyAcc

	SET @command = 'DIR "' + @directory +'" /B'
	EXEC @result = xp_cmdshell @command, NO_OUTPUT

	--ha mg nem ltezik a mappa
	IF @result <> 0
	BEGIN
		SET @command = 'MKDIR "' + @directory +'"'
		EXEC @result = xp_cmdshell @command, NO_OUTPUT

		--ha nem sikerlt ltrehozni
		IF @result <> 0
		BEGIN
			REVERT
			DELETE FROM TMP_DOC WHERE CreUser = @creUser AND DocPath = @path
			SELECT -3 AS hiba, 'Sikertelen mappa ltrehozs: ' + @directory AS hibaszov
			RETURN
		END

		--ellenrzs
		SET @command = 'DIR "' + @directory +'" /B'
		EXEC @result = xp_cmdshell @command, NO_OUTPUT

		--ha nem ltezik a mappa
		IF @result <> 0
		BEGIN
			REVERT
			DELETE FROM TMP_DOC WHERE CreUser = @creUser AND DocPath = @path
			SELECT -4 AS hiba, 'Nincs meg a mappa: ' + @directory AS hibaszov
			RETURN
		END
	END

	--ha mr ltezik a fjl, elszr trls, hogy biztos ki legyen cserlve
	SET @command = 'DIR "' + @path +'" /B'
	EXEC @result = xp_cmdshell @command, NO_OUTPUT

	IF @result = 0
	BEGIN
		SET @command = 'DEL "' + @path +'"'
		EXEC @result = xp_cmdshell @command, NO_OUTPUT

		IF @result <> 0
		BEGIN
			REVERT
			DELETE FROM TMP_DOC WHERE CreUser = @creUser AND DocPath = @path
			SELECT -5 AS hiba, 'Sikertelen trls: ' + @path AS hibaszov
			RETURN
		END

		SET @command = 'DIR "' + @path +'" /B'
		EXEC @result = xp_cmdshell @command, NO_OUTPUT

		IF @result = 0
		BEGIN
			REVERT
			DELETE FROM TMP_DOC WHERE CreUser = @creUser AND DocPath = @path
			SELECT -6 AS hiba, 'Sikertelen trls (ellenrzs): ' + @path AS hibaszov
			RETURN
		END
	END

	INSERT INTO TMP_DOC (DokumenTxt, CreUser, DocPath) VALUES(@dokumenTxt, @creUser, @path)

	SET @command = N'bcp "SELECT dokumentxt COLLATE SQL_Hungarian_CP1250_CI_AS FROM ' + DB_NAME() + N'.dbo.TMP_DOC WITH (NOLOCK) WHERE CreUser = ' + CAST(@creUser AS varchar) + N' AND DocPath = ''' + @path + N'''" queryout "' + @path + N'" -T -c -C RAW -r -S ' + @@SERVERNAME
	EXEC @result = xp_cmdshell @command, NO_OUTPUT

	IF @result <> 0
	BEGIN
		REVERT
		DELETE FROM TMP_DOC WHERE CreUser = @creUser AND DocPath = @path
		SELECT -7 AS hiba, 'Sikertelen fjl ltrehozs: ' + @path AS hibaszov
		RETURN
	END

	--ellenrzs
	SET @command = 'DIR "' + @path +'" /B'
	EXEC @result = xp_cmdshell @command, NO_OUTPUT

	REVERT
	DELETE FROM TMP_DOC WHERE CreUser = @creUser AND DocPath = @path

	IF @result <> 0
	BEGIN
		SELECT -8 AS hiba, 'Nincs meg a fjl: ' + @path AS hibaszov
		RETURN
	END

	SELECT 0 AS hiba, 'OK' AS hibaszov

END TRY
BEGIN CATCH
	REVERT
	SELECT -9 AS hiba, ERROR_MESSAGE() AS hibaszov
END CATCH

END