CREATE PROCEDURE [dbo].[sp_fajl_select] @path varchar(150), @nullCsere bit = 1
AS
BEGIN

BEGIN TRY

	DECLARE @LotsOfText varchar(MAX), @result int = 1, @command nvarchar(500), @proxyAcc varchar(50) = (SELECT TOP 1 LTRIM(RTRIM(ProxyAcc)) FROM CEG ORDER BY CegID)

	IF(@proxyAcc IS NULL OR @proxyAcc = '')
	BEGIN
		SELECT -1 AS hiba, 'Nincs megadva a cg trzsben a Proxy Account' AS hibaszov
		RETURN
	END	

	EXECUTE AS USER = @proxyAcc

	SET @command = 'DIR "' + @path +'" /B'
	EXEC @result = xp_cmdshell @command, NO_OUTPUT

	IF @result <> 0
		SELECT -2 AS hiba, 'Nincs meg a fjl: ' + @path AS hibaszov
	ELSE
	BEGIN
		CREATE TABLE #Dokument (dokumenTxt ntext)
	
		SET @command = 'SELECT @LotsOfText = BulkColumn FROM OPENROWSET(BULK '''+REPLACE(@path,'''','''''')+''', SINGLE_BLOB) AS x'
		EXEC sp_executeSql @command, N'@LotsOfText varchar(max) output', @LotsOfText OUTPUT
		SET @result = LEN(@LotsOfText)

		IF @result IS NULL
			SELECT -3 AS hiba, 'Sikertelen megnyits: ' + @path AS hibaszov
		ELSE
		BEGIN
			IF @nullCsere = 1
				INSERT INTO #Dokument (dokumenTxt) VALUES (REPLACE(CAST(@LotsOfText AS varchar(MAX)) COLLATE SQL_Hungarian_CP1250_CI_AS, char(0), CONVERT(varchar(10), master.dbo.fn_varbintohexstr(0))))
			ELSE
				INSERT INTO #Dokument (dokumenTxt) VALUES (CAST(@LotsOfText AS varchar(MAX)) COLLATE SQL_Hungarian_CP1250_CI_AS)

			SELECT 0 AS hiba, (SELECT dokumenTxt FROM #Dokument) AS fajl
		END
	END
	REVERT

END TRY
BEGIN CATCH
	REVERT
	SELECT -4 AS hiba, ERROR_MESSAGE() AS hibaszov
END CATCH

END