CREATE PROCEDURE [dbo].[sp_fajlok] @directory varchar(100), @filter varchar(50) = NULL
AS
BEGIN

BEGIN TRY

	DECLARE @LotsOfText varchar(MAX), @result int = 1, @command nvarchar(500), @proxyAcc varchar(50) = (SELECT TOP 1 LTRIM(RTRIM(ProxyAcc)) FROM CEG ORDER BY CegID)

	IF(@proxyAcc IS NULL OR @proxyAcc = '')
	BEGIN
		SELECT -1 AS hiba, 'Nincs megadva a cg trzsben a Proxy Account' AS hibaszov
		RETURN
	END	

	IF OBJECT_ID('tempdb..#DirectoryTree') IS NOT NULL
		  DROP TABLE #DirectoryTree;

	CREATE TABLE #DirectoryTree (filename varchar(200));

	EXECUTE AS USER = @proxyAcc

	--csak fjlok s csak fjlnv
	SET @command = 'DIR "' + @directory + '" /A-D /B'
	INSERT #DirectoryTree (filename)
	EXEC xp_cmdshell @command

	IF @filter IS NULL
		SELECT filename FROM #DirectoryTree WHERE filename IS NOT NULL
	ELSE
	BEGIN
		SELECT filename FROM #DirectoryTree
		WHERE filename LIKE @filter
		ORDER BY filename;
	END

	REVERT

END TRY
BEGIN CATCH
	REVERT
	SELECT -2 AS hiba, ERROR_MESSAGE() AS hibaszov
END CATCH

END