create PROCEDURE [dbo].[sp_kontir_select]
   @p0 tinyint,@p1 date,@p2 date,@p3 varchar(8),@p4 varchar(8)
AS
BEGIN
SET DEADLOCK_PRIORITY LOW
	SET NOCOUNT ON;
	SELECT sztukor.szsz,sztukor.neve,tetelfej.bizkelt,tetelfej.bizszam,tetelfej.bbizszam,esztukor.eszsz,isnull(asztukor.aszsz,'') as aszsz,
   dbo.iiflm(kontir.tkjel,kontir.osszeg,0) as tartozik,dbo.iiflm(kontir.tkjel,0,kontir.osszeg) as kovetel,
naplofej.naplotip,naplofej.bkod,tetelsor.bizszov,rgzneve,rgznaplo.konyvmod,fixszovnev

 from sztukor
 inner join kontir on sztukor.sztukorid=kontir.sztukorID
 left join esztukor on kontir.eszszID=esztukor.esztukorID
 left join asztukor on kontir.aszszID=asztukor.asztukorID
 inner join tetelsor on kontir.tetelsorID=tetelsor.tetelsorID
 inner join tetelfej on tetelsor.tetelfejID=tetelfej.tetelfejID
 inner join naplofej on tetelfej.naploid=naplofej.naploID
 left join rgznaplo on tetelfej.rgzid=rgznaplo.rgzid
 left join fixszov on tetelsor.stszovid=fixszov.fixszovid
  where sztukor.KonyvEv=@p0 and @p3<=sztukor.szsz and @p4>=sztukor.szsz and
    @p2>=tetelfej.bizkelt and @p1<=tetelfej.bizkelt
 order by szsz,bizkelt,bbizszam
END