create PROCEDURE [dbo].[sp_ktgfel_select]
   @px tinyint,@p0 tinyint,@p1 date,@p2 date,@p3 varchar(8),@p4 varchar(8), @p5 smalldatetime
as
BEGIN

if @px=1
begin
select szsz,neve,ktghkod,ktghnev,munkkod,munknev,sum(dbo.iiflm(tkjel,kt.osszeg,0)) as tartozik,sum(dbo.iiflm(TKjel,0,kt.Osszeg)) as kovetel from ktg_fel kt
left join ktghely ktg on kt.ktghelyid=ktg.ktghelyid
left join munkszam m on m.munkid=kt.munkid
left join TETELSOR ts on kt.TetelsorID=ts.TetelsorID
left join SZTUKOR sz on ts.SzszID=sz.Sztukorid 
left join TETELFEJ tf on ts.TetelfejID =tf.TetelfejID 
where bizkelt>=@p1 and Bizkelt<=@p2  and szsz>=@p3 and szsz<=@p4 and tf.Cretime<=@p5
group by szsz,neve,Ktghkod,ktghnev,munkkod,munknev
union all
select szsz,neve,ktghkod,ktghnev,munkkod,munknev,sum(dbo.iiflm(TKjel,0,kt.osszeg)) as tartozik,sum(dbo.iiflm(tkjel,kt.osszeg,0)) as  kovetel from ktg_fel kt
left join ktghely ktg on kt.ktghelyid=ktg.ktghelyid
left join munkszam m on m.munkid=kt.munkid
left join TETELSOR ts on kt.TetelsorID=ts.TetelsorID
left join SZTUKOR sz on ts.eSzszID=sz.Sztukorid 
left join TETELFEJ tf on ts.TetelfejID =tf.TetelfejID 
where bizkelt>=@p1 and Bizkelt<=@p2  and szsz>=@p3 and szsz<=@p4 and tf.Cretime<=@p5
group by szsz,neve,Ktghkod,ktghnev,munkkod,munknev
order by Szsz,Ktghkod,munkkod 
end

if @px=2
begin
select szsz,neve,ktghkod,ktghnev,munkkod,munknev,sum(dbo.iiflm(tkjel,kt.osszeg,0)) as tartozik,sum(dbo.iiflm(TKjel,0,kt.Osszeg)) as kovetel from ktg_fel kt
left join ktghely ktg on kt.ktghelyid=ktg.ktghelyid
left join munkszam m on m.munkid=kt.munkid
left join TETELSOR ts on kt.TetelsorID=ts.TetelsorID
left join SZTUKOR sz on ts.SzszID=sz.Sztukorid 
left join TETELFEJ tf on ts.TetelfejID =tf.TetelfejID 
where bizkelt>=@p1 and Bizkelt<=@p2  and ktghkod>=@p3 and ktghkod<=@p4 and tf.Cretime<=@p5
group by szsz,neve,Ktghkod,ktghnev,munkkod,munknev
union all
select szsz,neve,ktghkod,ktghnev,munkkod,munknev,sum(dbo.iiflm(TKjel,0,kt.osszeg)) as tartozik,sum(dbo.iiflm(tkjel,kt.osszeg,0)) as  kovetel from ktg_fel kt
left join ktghely ktg on kt.ktghelyid=ktg.ktghelyid
left join munkszam m on m.munkid=kt.munkid
left join TETELSOR ts on kt.TetelsorID=ts.TetelsorID
left join SZTUKOR sz on ts.eSzszID=sz.Sztukorid 
left join TETELFEJ tf on ts.TetelfejID =tf.TetelfejID 
where bizkelt>=@p1 and Bizkelt<=@p2  and ktghkod>=@p3 and ktghkod<=@p4 and tf.Cretime<=@p5
group by szsz,neve,Ktghkod,ktghnev,munkkod,munknev
order by Szsz,Ktghkod,munkkod 
end


if @px=3
begin
select szsz,neve,ktghkod,ktghnev,munkkod,munknev,sum(dbo.iiflm(tkjel,kt.osszeg,0)) as tartozik,sum(dbo.iiflm(TKjel,0,kt.Osszeg)) as kovetel from ktg_fel kt
left join ktghely ktg on kt.ktghelyid=ktg.ktghelyid
left join munkszam m on m.munkid=kt.munkid
left join TETELSOR ts on kt.TetelsorID=ts.TetelsorID
left join SZTUKOR sz on ts.SzszID=sz.Sztukorid 
left join TETELFEJ tf on ts.TetelfejID =tf.TetelfejID 
where bizkelt>=@p1 and Bizkelt<=@p2 and munkkod>=@p3 and munkkod<=@p4 and tf.Cretime<=@p5
group by munkkod,munknev,szsz,neve,Ktghkod,ktghnev
union all
select szsz,neve,ktghkod,ktghnev,munkkod,munknev,sum(dbo.iiflm(TKjel,0,kt.osszeg)) as tartozik,sum(dbo.iiflm(tkjel,kt.osszeg,0)) as  kovetel from ktg_fel kt
left join ktghely ktg on kt.ktghelyid=ktg.ktghelyid
left join munkszam m on m.munkid=kt.munkid
left join TETELSOR ts on kt.TetelsorID=ts.TetelsorID
left join SZTUKOR sz on ts.eSzszID=sz.Sztukorid 
left join TETELFEJ tf on ts.TetelfejID =tf.TetelfejID 
where bizkelt>=@p1 and Bizkelt<=@p2  and munkkod>=@p3 and munkkod<=@p4 and tf.Cretime<=@p5
group by munkkod,munknev,szsz,neve,Ktghkod,ktghnev
order by Szsz,Ktghkod,munkkod 
end


if @px=4
begin
select naplonev,szsz,neve,ktghkod,ktghnev,bizkelt,bbizszam,bizszam,bizszov,munkkod,munknev,dbo.iiflm(tkjel,kt.osszeg,0) as tartozik,dbo.iiflm(TKjel,0,kt.Osszeg) as kovetel,0 as egyenleg,ktgfelID,munknev,ts.szallitoid,szneve from ktg_fel kt
left join ktghely ktg on kt.ktghelyid=ktg.ktghelyid
left join munkszam m on m.munkid=kt.munkid
left join TETELSOR ts on kt.TetelsorID=ts.TetelsorID
left join SZTUKOR sz on ts.SzszID=sz.Sztukorid 
left join TETELFEJ tf on ts.TetelfejID =tf.TetelfejID 
left join naplofEJ nf on nf.naploid =tf.naploid 
left join szallito on szallito.szallitoid=ts.szallitoid
where bizkelt>=@p1 and Bizkelt<=@p2  and  szsz>=@p3 and szsz<=@p4 and tf.Cretime<=@p5

union all
select naplonev,szsz,neve,ktghkod,ktghnev,bizkelt,bbizszam,bizszam,bizszov,munkkod,munknev,dbo.iiflm(TKjel,0,kt.osszeg) as tartozik,dbo.iiflm(tkjel,kt.osszeg,0) as  kovetel,0 as egyenleg,ktgfelID,munknev,ts.szallitoid,szneve  from ktg_fel kt
left join ktghely ktg on kt.ktghelyid=ktg.ktghelyid
left join munkszam m on m.munkid=kt.munkid
left join TETELSOR ts on kt.TetelsorID=ts.TetelsorID
left join SZTUKOR sz on ts.eSzszID=sz.Sztukorid 
left join TETELFEJ tf on ts.TetelfejID =tf.TetelfejID 
left join naplofEJ nf on nf.naploid =tf.naploid 
left join szallito on szallito.szallitoid=ts.szallitoid

where bizkelt>=@p1 and Bizkelt<=@p2 and szsz>=@p3 and szsz<=@p4 and tf.Cretime<=@p5
order by Szsz,Ktghkod,munkkod 
end


if @px=5
begin
select month(bizkelt) as ho,szsz,neve,ktghkod,ktghnev,munkkod,munknev,sum(dbo.iiflm(tkjel,kt.osszeg,0)) as tartozik,sum(dbo.iiflm(TKjel,0,kt.Osszeg)) as kovetel from ktg_fel kt
left join ktghely ktg on kt.ktghelyid=ktg.ktghelyid
left join munkszam m on m.munkid=kt.munkid
left join TETELSOR ts on kt.TetelsorID=ts.TetelsorID
left join SZTUKOR sz on ts.SzszID=sz.Sztukorid 
left join TETELFEJ tf on ts.TetelfejID =tf.TetelfejID 
where bizkelt>=@p1 and Bizkelt<=@p2 and tf.Cretime<=@p5
group by month(bizkelt),munkkod,munknev,szsz,neve,Ktghkod,ktghnev
union all
select month(bizkelt) as ho,szsz,neve,ktghkod,ktghnev,munkkod,munknev,sum(dbo.iiflm(TKjel,0,kt.osszeg)) as tartozik,sum(dbo.iiflm(tkjel,kt.osszeg,0)) as  kovetel from ktg_fel kt
left join ktghely ktg on kt.ktghelyid=ktg.ktghelyid
left join munkszam m on m.munkid=kt.munkid
left join TETELSOR ts on kt.TetelsorID=ts.TetelsorID
left join SZTUKOR sz on ts.eSzszID=sz.Sztukorid 
left join TETELFEJ tf on ts.TetelfejID =tf.TetelfejID 
where bizkelt>=@p1 and Bizkelt<=@p2  and tf.Cretime<=@p5
group by MONTH(bizkelt),munkkod,munknev,szsz,neve,Ktghkod,ktghnev
order by Szsz,Ktghkod,munkkod 
end


if @px=7
begin
select szsz,neve,mszsz,mneve,munkkod,munknev,sum(dbo.iiflm(tkjel,kt.osszeg,0)) as tartozik,sum(dbo.iiflm(TKjel,0,kt.Osszeg)) as kovetel from ktg_fel kt
left join msztukor on kt.mszszid=msztukor.msztukorid
left join munkszam m on m.munkid=kt.munkid
left join TETELSOR ts on kt.TetelsorID=ts.TetelsorID
left join SZTUKOR sz on ts.SzszID=sz.Sztukorid 
left join TETELFEJ tf on ts.TetelfejID =tf.TetelfejID 
where bizkelt>=@p1 and Bizkelt<=@p2 and (LEFT(szsz,1)='6' or LEFT(szsz,1)='7') and mszsz>=@p3 and mszsz<=@p4 and tf.Cretime<=@p5 and konyvelve='I'
group by szsz,neve,mszsz,mneve,munkkod,munknev
union all
select szsz,neve,mszsz,mneve,munkkod,munknev,sum(dbo.iiflm(TKjel,0,kt.osszeg)) as tartozik,sum(dbo.iiflm(tkjel,kt.osszeg,0)) as  kovetel from ktg_fel kt
left join msztukor on kt.mszszid=msztukor.msztukorid
left join munkszam m on m.munkid=kt.munkid
left join TETELSOR ts on kt.TetelsorID=ts.TetelsorID
left join SZTUKOR sz on ts.eSzszID=sz.Sztukorid 
left join TETELFEJ tf on ts.TetelfejID =tf.TetelfejID 
where bizkelt>=@p1 and Bizkelt<=@p2 and (LEFT(szsz,1)='6' or LEFT(szsz,1)='7') and mszsz>=@p3 and mszsz<=@p4 and tf.Cretime<=@p5 and konyvelve='I'
group by szsz,neve,mszsz,mneve,munkkod,munknev
order by Szsz,mszsz,munkkod 
end


if @px=8
begin
select szsz,neve,mszsz,mneve,munkkod,munknev,sum(dbo.iiflm(tkjel,kt.osszeg,0)) as tartozik,sum(dbo.iiflm(TKjel,0,kt.Osszeg)) as kovetel from ktg_fel kt
left join msztukor on kt.mszszid=msztukor.msztukorid
left join munkszam m on m.munkid=kt.munkid
left join TETELSOR ts on kt.TetelsorID=ts.TetelsorID
left join SZTUKOR sz on ts.SzszID=sz.Sztukorid 
left join TETELFEJ tf on ts.TetelfejID =tf.TetelfejID 
where bizkelt>=@p1 and Bizkelt<=@p2 and (LEFT(szsz,1)='6' or LEFT(szsz,1)='7') and szsz>=@p3 and szsz<=@p4 and tf.Cretime<=@p5 and konyvelve='I'
group by szsz,neve,mszsz,mneve,munkkod,munknev
union all
select szsz,neve,mszsz,mneve,munkkod,munknev,sum(dbo.iiflm(TKjel,0,kt.osszeg)) as tartozik,sum(dbo.iiflm(tkjel,kt.osszeg,0)) as  kovetel from ktg_fel kt
left join msztukor on kt.mszszid=msztukor.msztukorid
left join munkszam m on m.munkid=kt.munkid
left join TETELSOR ts on kt.TetelsorID=ts.TetelsorID
left join SZTUKOR sz on ts.eSzszID=sz.Sztukorid 
left join TETELFEJ tf on ts.TetelfejID =tf.TetelfejID 
where bizkelt>=@p1 and Bizkelt<=@p2 and (LEFT(szsz,1)='6' or LEFT(szsz,1)='7') and szsz>=@p3 and szsz<=@p4 and tf.Cretime<=@p5 and konyvelve='I'
group by szsz,neve,mszsz,mneve,munkkod,munknev
order by Szsz,mszsz,munkkod 
end


if @px=9
begin
select szsz,neve,mszsz,mneve,munkkod,munknev,sum(dbo.iiflm(tkjel,kt.osszeg,0)) as tartozik,sum(dbo.iiflm(TKjel,0,kt.Osszeg)) as kovetel from ktg_fel kt
left join msztukor on kt.mszszid=msztukor.msztukorid
left join munkszam m on m.munkid=kt.munkid
left join TETELSOR ts on kt.TetelsorID=ts.TetelsorID
left join SZTUKOR sz on ts.SzszID=sz.Sztukorid 
left join TETELFEJ tf on ts.TetelfejID =tf.TetelfejID 
where bizkelt>=@p1 and Bizkelt<=@p2 and (LEFT(szsz,1)='6' or LEFT(szsz,1)='7'  ) and munkkod>=@p3 and munkkod<=@p4 and tf.Cretime<=@p5 and konyvelve='I'
group by munkkod,munknev,szsz,neve,mszsz,mneve
union all
select szsz,neve,mszsz,mneve,munkkod,munknev,sum(dbo.iiflm(TKjel,0,kt.osszeg)) as tartozik,sum(dbo.iiflm(tkjel,kt.osszeg,0)) as  kovetel from ktg_fel kt
left join msztukor on kt.mszszid=msztukor.msztukorid
left join munkszam m on m.munkid=kt.munkid
left join TETELSOR ts on kt.TetelsorID=ts.TetelsorID
left join SZTUKOR sz on ts.eSzszID=sz.Sztukorid 
left join TETELFEJ tf on ts.TetelfejID =tf.TetelfejID 
where bizkelt>=@p1 and Bizkelt<=@p2 and (LEFT(szsz,1)='6' or LEFT(szsz,1)='7'  ) and munkkod>=@p3 and munkkod<=@p4 and tf.Cretime<=@p5 and konyvelve='I'
group by munkkod,munknev,szsz,neve,mszsz,mneve
order by munkkod,mszsz,szsz 
end




if @px=10
begin
select szsz,neve,mszsz,mneve,bizkelt,bbizszam,bizszam,bizszov,isnull(munkkod,'') as munkkod,munknev,dbo.iiflm(tkjel,kt.osszeg,0) as tartozik,dbo.iiflm(TKjel,0,kt.Osszeg) as kovetel,0 as egyenleg,mszszID,munknev,ts.szallitoid,szneve,Iktid from ktg_fel kt
left join msztukor on kt.mszszid=msztukor.msztukorid
left join munkszam m on m.munkid=kt.munkid
left join TETELSOR ts on kt.TetelsorID=ts.TetelsorID
left join szallito on ts.szallitoid=szallito.szallitoid
left join SZTUKOR sz on ts.SzszID=sz.Sztukorid 
left join TETELFEJ tf on ts.TetelfejID =tf.TetelfejID 
where bizkelt>=@p1 and Bizkelt<=@p2 and (LEFT(szsz,1)='6' or LEFT(szsz,1)='7'   ) and  tf.Cretime<=@p5 and konyvelve='I'
union all
select szsz,neve,mszsz,mneve,bizkelt,bbizszam,bizszam,bizszov,isnull(munkkod,'') as munkkod,munknev,dbo.iiflm(TKjel,0,kt.osszeg) as tartozik,dbo.iiflm(tkjel,kt.osszeg,0) as  kovetel,0 as egyenleg,mszszID,munknev,ts.szallitoid,szneve,IktID from ktg_fel kt
left join msztukor on kt.mszszid=msztukor.msztukorid
left join munkszam m on m.munkid=kt.munkid
left join TETELSOR ts on kt.TetelsorID=ts.TetelsorID
left join szallito on ts.szallitoid=szallito.szallitoid
left join SZTUKOR sz on ts.eSzszID=sz.Sztukorid 
left join TETELFEJ tf on ts.TetelfejID =tf.TetelfejID 
where bizkelt>=@p1 and Bizkelt<=@p2 and (LEFT(szsz,1)='6' or LEFT(szsz,1)='7'  ) and tf.Cretime<=@p5 and konyvelve='I'
order by mSzsz,szsz,munkkod 
end

END
