CREATE PROCEDURE [dbo].[sp_rendssor_update]
	@bizsorID int
AS
BEGIN
	DECLARE @rendssorID int, @rendssorMennyi decimal(8,2), @bizsorMennyi decimal(10,3)

	SET NOCOUNT ON;

	SELECT @rendssorID = RendssorID, @rendssorMennyi = Mennyi FROM RENDSSOR WHERE BizsorID = @bizsorID
		
	--ha van rendels - bizonylat prosts
	IF(@rendssorID IS NOT NULL)
	BEGIN
		SELECT @bizsorMennyi = Mennyi FROM BIZSOR WHERE BizsorID = @bizsorID
			
		--tbb a rendels, mint a bevtelezett -> soroszts
		IF(@rendssorMennyi > @bizsorMennyi)
		BEGIN
			UPDATE RENDSSOR SET Mennyi = @bizsorMennyi WHERE RendssorID = @rendssorID
				
			INSERT INTO RENDSSOR (RendsfejID, CikkID, szolgID, Mennyi, Egysegar, Ehatarido, Rtipus, Megjegyz, Afaid, kedvezs, RsorMeid, RaktID) 
								 (SELECT RendsfejID, CikkID, szolgID, @rendssorMennyi - @bizsorMennyi, Egysegar, Ehatarido, Rtipus, Megjegyz, Afaid, kedvezs, RsorMeid, RaktID FROM RENDSSOR WHERE RendssorID = @rendssorID)
		END
	END
END