CREATE PROCEDURE [dbo].[sp_shrink]
AS
BEGIN
	DECLARE  @fileName varchar(255)

	
	IF CURSOR_STATUS('global','ShrinkCursor')>=-1
	BEGIN
		CLOSE ShrinkCursor
		DEALLOCATE ShrinkCursor
	END

	DECLARE ShrinkCursor CURSOR FOR

	SELECT name FROM sys.master_files WHERE database_id = db_id() AND (name LIKE '%_log%' OR name LIKE '%_doc%') ORDER BY type

	OPEN ShrinkCursor

	FETCH NEXT FROM ShrinkCursor INTO @fileName
	WHILE @@FETCH_STATUS = 0
	BEGIN
		DBCC ShrinkFile(@fileName)
		FETCH NEXT FROM ShrinkCursor INTO @fileName
	END

	CLOSE ShrinkCursor
	DEALLOCATE ShrinkCursor
END
