CREATE procedure [dbo].[sp_szla_insert]
as
begin
 declare @szamlaID int,@vevoid int,@szkelt date,@fizhat date,@tkelt date,@fizmodid tinyint,@netto money,@brutto money,@kedvezmeny numeric (5,2),@creUser smallint,@szszID int,@eszszID int,@osszeg money,@irany char(1),@iranyl bit,
 @tetszam int, @szlanevid int,@fohelyid int,@regiora varchar(6),@ujora varchar(6),@m3 int,@egysegar numeric (17,6),@afaid int,@szsorId int,@afaosszeg money,@tipus char(1),@szlahiv char(12),@kontid int,@kdatum date,
 @tombID int,@szszam varchar(12),@tombsorsz int,@aszszID int,@SzolgID int,@mennyiseg numeric(12,4),@afakulcs tinyint,@eloszov varchar(500),@utoszov varchar(500),@kpvevonev varchar(8000),@tetelsorID int,
 @fizeto int,@tetelfejID int,@tombjel char(3),@tombkepzes char(1),@elonull tinyint,@jogcimID int,@jogcimkod char(6),@Rjogcimkod char(6),@pnaplo char(1),@pnaplokod char(1),@naploID2 int,@rgznaploid2 int,
 @naploID int,@konyvev tinyint,@bbizszam char(12),@konttet tinyint,@neve varchar(50),@rgznaploid int,@bizszov varchar(50),@naturalia numeric(10),@rgzneve char(11),@bizszov2 char(30),@egyeb varchar(200),
 @devizaid tinyint,@devizaert money,@arfolyam smallmoney,@devizaar money,@devizafiz money,@cikkID int,@raktarid int,@KellKeszlet bit,@szla_biz int,@mozgnemid int,@munkid int,@mosszeg money,@szkonyvEv tinyint
 declare @uzemekid int,@keszl_afaid tinyint,@atlagar money,@proforma bit,@tombel char(1),@tombelk char(1),@ktghelyid int,@bankom tinyint,@bankid smallint,@fejlecID tinyint,@KeszPrgID tinyint,@verzioSzam varchar(15),@KulonAFA char(1) 
 declare @KamatCalc bit,@keskamtip tinyint,@fuvarjesID int,@sztetelID int
 select @vevoid=vevoid,@szkelt=szkelt,@fizhat=fizhat,@tkelt=tkelt,@fizmodid=fizmodid,@netto=netto,@brutto=brutto,@kedvezmeny=kedvezmeny,
 @creuser=creuser,@tetszam=tetszam,@tombid=tombid,@konttet=konttet,@szlahiv=szlahiv,
 @fizeto=fizeto,@tetelfejID=tetelfejID,@naploID=naploID,@Eloszov=Eloszov,@Utoszov=utoszov,@kpvevonev=Kpvevonev,@pnaplo=pnaplo,@pnaplokod=pnaplokod, 
 @devizaid=devizaid,@devizaert=devizaert,@arfolyam=arfolyam,@kdatum=kdatum,@bankom=bankom,@bankid=bankid,@keszPrgID=KeszPrgID,@VerzioSzam=VerzioSzam,@KulonAFA=kulonAFA from #szfej
set @netto=round( @netto*@arfolyam,0)
set @brutto=round( @brutto*@arfolyam,0)
if @arfolyam=1
  set @devizaert=null
begin try
 begin tran
 
 --- Meglv
 --if @tetelfejID=-1
 --  begin
     select  @rgznaploid=rgzID,@rgzneve=rgzneve from RGZNAPLO
         where NaploID=@naploID and Zart='N'
     if isnull(@rgznaploid,0)=0
        select @tetelfejID=0 
 --    end
 select @proforma=proforma,@fejlecID=fejlecID from SZLATOMB where TombID=@tombID
 
 
 --- j -----
if isnull(@proforma,'False')='False'
  begin
 if @tetelfejID=0 
   begin
     update rgznaplo set zart='I' where NaploID=@naploID and Zart='N'
     select @rgzneve=naplofej.naplotip+naplofej.bkod+right(rtrim(evek.Ev),2)+'-'+right('00'+ltrim(str(month(@szkelt),2)),2)+'-'+right('000'+ltrim(str(naplofej.RgzSorszam,3)),3)
           from naplofej
           left join evek on naplofej.KonyvEv=evek.evekID
           where naploID=@naploID  
     insert into RGZNAPLO (NaploID,creUser,Neve,Zart,rgzneve)
       values (@naploID,@creUser,@neve,'N',@rgzneve)
     select @rgznaploid=SCOPE_IDENTITY()
    end 
     update naplofej set sorszam=sorszam+1 where naploID=@naploID
          select @KonyvEv=naplofej.KonyvEv,
           @bbizszam=naplofej.naplotip+naplofej.bkod+right(rtrim(evek.Ev),2)+'-'+right('00000'+ltrim(str(sorszam,naplofej.bizhosz)),naplofej.bizhosz)
           from naplofej
              left join evek on naplofej.KonyvEv=evek.evekID
              where naploID=@naploID 
  
      if @kdatum is null or @kdatum='1900.01.01'
          set @kdatum=@tkelt
  
      insert into tetelfej (naploID,bizkelt,ekelt,bbizszam,bizszam,CreUser,tetelszam,KonyvEv,Naplotip,RgzID,arfolyam  ) 
             values(@naploID,@kdatum,@tkelt,@bbizszam,@szszam,@creUser,0,@KonyvEv,'V',@rgznaploid,@arfolyam)
      select @tetelfejID=SCOPE_IDENTITY() 
   end
   
 
 
 select @szkonyvEv=EvekID from evek where left(evek.ev,4)=str(year(@szkelt),4)
 
 update SZLATMBS set TombSorsz=TombSorsz+1,last_kelt=@szkelt where  tombID=@tombID and TombEv=@szkonyvEV
 select @tombsorsz=TombSorsz,@szszam=tombevKep from szlatmbs where  tombID=@tombID and TombEv=@szkonyvEV
 select @tombjel=tombjel,@tombkepzes=tombkepzes,@elonull=elonull,@jogcimkod=jogcimkod,@Rjogcimkod=Rjogcimkod,@tombelk=isnull(tombelk,''),@tombel=isnull(tombel,''),@keskamtip=isnull(keskamtip,0) from SZLATOMB where TombID=@tombID
 if @tombkepzes='B' 
    set @szszam=RTRIM(@tombjel)+rtrim(@tombel)+rtrim(@szszam)+rtrim(@tombelk)+right('00000'+ltrim(STR(@tombsorsz)),@elonull)
  if @tombkepzes='S' 
    set @szszam=right('00000'+ltrim(STR(@tombsorsz)),@elonull)+rtrim(@tombel)+rtrim(@tombjel)+rtrim(@tombelk)+RTRIM(@szszam)
  if @tombkepzes='N' 
    set @szszam=right('00000'+ltrim(STR(@tombsorsz)),@elonull)+rtrim(@tombel)+rtrim(@szszam)+rtrim(@tombelk)+RTRIM(@tombjel)
 
if @keskamtip=3
  set @kamatCalc=0
else
  set @kamatCalc=1

---select @jogcimID=jogcimID from jogcim where jogcimkod=@jogcimkod and KOnyvEv=@KonyvEv
 if @devizaID<>1
   set @devizafiz=0
 else
   set @devizafiz=null
 
 if isnull(@proforma,'False')='False'
begin
	insert into szamlak (vevoid,fizeto,szszam,szkelt,fizhat,tkelt,fizmodid,netto,brutto,kedvezmeny,creuser,TetelfejID,Eloszov,Utoszov,KpVevonev,tombid,szlahiv,devizaid,devizaert,devizafiz,bankomID,arfolyam,bankid,fejlecID,KeszPrgID,VerzioSzam,KulonAFA,KamatCalc)
				 values (@vevoid,@fizeto,@szszam,@szkelt,@fizhat,@tkelt,@fizmodid,@netto,@brutto,@kedvezmeny,@creUser,@tetelfejID,@Eloszov,@Utoszov,@KpVevonev,@tombid,@szlahiv,@devizaid,@devizaert,@devizafiz,@bankom,@arfolyam,@bankid,@fejlecID,@KeszPrgID,@VerzioSzam,@KulonAFA,@KamatCalc)
    
	set @szamlaID=SCOPE_IDENTITY()
    update TETELFEJ set Bizszam=@szszam where TetelfejID=@tetelfejID

    set @szla_biz=0
    set @kellkeszlet=0

    if rtrim(dbo.fc_setup('R',@konyvev,112))='Igen'
      set @KellKeszlet=1

    set @szsorid=1
    while @tetszam>=@szsorID
    begin
		select @szolgid=szolgid,@raktarid=raktarid,@egyeb=egyeb,
			   @mennyiseg=mennyiseg,@egysegar=egysegar,@afaid=afaid,@afakulcs=afakulcs,@tipus=tipus,@devizaar=devizaar,@cikkid=cikkid,@munkid=munkid,@ktghelyid=ktghelyid,@fuvarjesID=FuvarjesID
		from #szsor where szsorID=@szsorID
		
		if @kellKeszlet=1 and not @raktarid is null and not @cikkid is null and @cikkid>0 and @raktarid>0
        begin
			if @szla_biz=0
			begin
				select @mozgnemid=mozgnemid from mozgnem where bizjel=dbo.fc_setup('R',@konyvev,116) and konyvev=@konyvev
				
				if @mozgnemID is null
				begin
					rollback tran
					select 0 as rgznaplo,'' as nev,Error_number() as hiba,'Nincs ilyen mozgsnem:'+dbo.fc_setup('R',@konyvev,116) as hibaszov,'' as szszam,0 as szamlaID
					return 
				end

				insert into bizfej (bizszam,kelt,vevoid,eredeti,netto,brutto,mozgnemid,munkszamid,creuser) 
							values ('1',@tkelt,@vevoid,@szszam,@netto,@brutto,@mozgnemid,@munkid,@creuser)
                 
				set @szla_biz=SCOPE_IDENTITY()
                 
				if @szla_biz is null or @szla_biz=0
				begin
					rollback tran
					select 0 as rgznaplo,'' as nev,Error_number() as hiba,'Nem lehet bizfejet ltrehozni! ' as hibaszov,'' as szszam,0 as szamlaID
					return 
				end
			end
			
			select @keszl_afaid=afaid from cikk where cikkid=@cikkID
			select @atlagar=atlagar from keszlet where cikkid=@cikkid and raktarid=@raktarid
			
			insert into bizsor (bizfejid,cikkid,raktarid,mennyi,egysegar,ertek,afaid) values (@szla_biz,@cikkid,@raktarid,@mennyiseg,@atlagar,round(@mennyiseg*@atlagar,0),@keszl_afaid)   
		end --&&van cikk s raktr

       insert into SZTETEL (SzamlaID,EgysegAr,mennyiseg,Afaid,AFAkulcs,SzolgID,CikkID,tipus,devizaAr,munkid,ktghelyid,egyeb,raktarid,TetelSorsz) 
					values (@szamlaID,@egysegar,@mennyiseg,@afaid,@afakulcs,@SzolgID,@CikkID,@tipus,@devizaAr,@munkid,@ktghelyid,@egyeb,@raktarid,@szsorid)

		IF @fuvarjesID IS NOT NULL
		BEGIN
			SET @sztetelID=SCOPE_IDENTITY()
			UPDATE FUVARJES SET SztetelID=@sztetelID WHERE FuvarjesID=@fuvarjesID
			--TODO maradk esetn sorbonts
		END  

		set @szsorid=@szsorid+1
	end
   
      set @szsorID=1 
      while @konttet>=@szsorID
        begin
          select @szszID=szszID,@eszszID=eszszID,@aszszID=aszszID,@osszeg=osszeg,@afaosszeg=afaosszeg,@bizszov=bizszov,@afaid=afaid,@jogcimid=jogcimid,@kontid=kontid,@uzemekid=uzemekid
            from #kont where kontID=@szsorID
          select @irany=irany from jogcim where jogcimid=@jogcimid
          if @irany='C'
             set @iranyl='False'
          else
            set @iranyl='True'
          insert into tetelsor (tetelfejID,vevoid,szamlaid,SzszID,eszszID,aszszID,osszeg,tkjel,Tartozik,AfaOsszeg,kvjel,sorszam,Bizszov,afaid,fizmodid,jogcimID,bkelt,uzemekid) 
              values (@tetelfejID,@fizeto,@szamlaid,@szszID,@eszszID,@aszszID,(@osszeg+@afaosszeg)/@arfolyam,@iranyl,@osszeg+@afaosszeg,@afaosszeg,'A',@szsorID,@bizszov,@afaid,@fizmodid,@jogcimID,@tkelt,@uzemekid)
          set @tetelsorID=SCOPE_IDENTITY()
          if rtrim(dbo.fc_setup('R',@konyvev,131))='Igen' or rtrim(dbo.fc_setup('R',@konyvev,171))='Igen'
            begin                
              select @munkid=count(*) from #ktgfel where kontid=@kontid and osszeg<>0
              if isnull(@munkid,0)>0
                begin
                  declare cur_ktg cursor for 
                     select munkid,ktghelyid,osszeg from #ktgfel where kontid=@kontid and osszeg<>0
                  open cur_ktg
                  fetch from cur_ktg into  @munkid,@ktghelyid,@mosszeg
                  while @@fetch_status=0
                   begin
                     insert into ktg_fel (tetelsorid,munkid,ktghelyid,osszeg) values (@tetelsorID,@munkid,@ktghelyid,@mosszeg)
                     fetch next from cur_ktg into @munkid,@ktghelyid,@mosszeg
                   end
                 close cur_ktg
                 deallocate cur_ktg
              end
            end  
          set @szsorid=@szsorid+1
        end -- kontr vge
    
  end -- Norml szmla nem proforma  
  if isnull(@proforma,'False') ='True'  -- Pfoforma szmla
    begin
       insert into pszamlak (vevoid,szszam,szkelt,fizhat,tkelt,fizmodid,netto,brutto,creuser,Eloszov,Utoszov,tombid,devizaid,devizaert)
            values (@vevoid,@szszam,@szkelt,@fizhat,@tkelt,@fizmodid,@netto,@brutto,@creUser,@Eloszov,@Utoszov,@tombid,@devizaid,@devizaert)
       set @szamlaID=SCOPE_IDENTITY()
       set @szsorid=1 
       while @tetszam>=@szsorID
        begin
           select @szolgid=szolgid,@raktarid=raktarid,@egyeb=egyeb,
             @mennyiseg=mennyiseg,@egysegar=egysegar,@afaid=afaid,@afakulcs=afakulcs,@tipus=tipus,@devizaar=devizaar,@cikkid=cikkid,@munkid=munkid 
             from #szsor where szsorID=@szsorID
              set @szsorid=@szsorid+1
             insert into pSZTETEL (PSzamlaID,EgysegAr,mennyiseg,Afaid,AFAkulcs,SzolgID,tipus,munkid,egyeb) 
              values (@szamlaID,@egysegar,@mennyiseg,@afaid,@afakulcs,@SzolgID,@tipus,@munkid,@egyeb)

         end  
    end --proformavge
    
---------- Rendezs nem fut r-----
   if @fizmodid=1 and @Rjogcimkod>' ' and @fizmodid=2
     begin
       
        select @jogcimID=jogcimID,@bizszov2=JOGCIM.Szoveg from jogcim where jogcimkod=@Rjogcimkod and KOnyvEv=@KonyvEv
        select @naploID2=naploID from NAPLOFEJ where naplotip=@pnaplo and bkod=@pnaplokod and KOnyvEv=@KonyvEv
        set  @jogcimID=ISNULL(@jogcimID,0)
        set @naploID2=ISNULL(@naploID2,0)
        if @naploID2>0 and @jogcimID>0
          begin
              select  @rgznaploid2=rgzID,@rgzneve=rgzneve from RGZNAPLO
         where NaploID=@naploID2 and Zart='N'
     if isnull(@rgznaploid2,0)=0
        begin
          select @rgzneve=naplofej.naplotip+naplofej.bkod+right(rtrim(evek.Ev),2)+'-'+right('00'+ltrim(str(month(@szkelt),2)),2)+'-'+right('000'+ltrim(str(naplofej.RgzSorszam,3)),3)
           from naplofej
              left join evek on naplofej.KonyvEv=evek.evekID
              where naploID=@naploID2  
  
            insert into RGZNAPLO (NaploID,creUser,Neve,Zart,rgzneve)
                values (@naploID2,@creUser,'','N',@rgzneve)
                select @rgznaploid2=SCOPE_IDENTITY() 
        end
          
          
              update naplofej set sorszam=sorszam+1 where naploID=@naploID2
          select @KonyvEv=naplofej.KonyvEv,@eszszID=NAPLOFEJ.Fszsz,
           @bbizszam=naplofej.naplotip+naplofej.bkod+right(rtrim(evek.Ev),2)+'-'+right('00000'+ltrim(str(sorszam,naplofej.bizhosz)),naplofej.bizhosz)
           from naplofej
              left join evek on naplofej.KonyvEv=evek.evekID
              where naploID=@naploID2 
  
                 
             insert into tetelfej (naploID,bizkelt,bbizszam,CreUser,tetelszam,KonyvEv,Naplotip,RgzID  ) 
             values(@naploID2,@tkelt,@bbizszam,@creUser,0,@KonyvEv,@pnaplo,@rgznaploid2)
             select @tetelfejID=SCOPE_IDENTITY() 
  
                insert into tetelsor (tetelfejID,vevoid,szamlaid,SzszID,eszszID,osszeg,tkjel,Tartozik,AfaOsszeg,kvjel,sorszam,Bizszov,fizmodid,jogcimID,szlahiv,bkelt) 
      values (@tetelfejID,@fizeto,@szamlaid,@eszszID,@szszID,(@osszeg+@afaosszeg)/@arfolyam,'True',@osszeg+@afaosszeg,0,'A',1,@bizszov2,@fizmodid,@jogcimID,@szszam,@szkelt)
 
    update szamlak set fizetett=@osszeg+@afaosszeg,fizetve=@szkelt where @szamlaID=szamlaID
 
            
          end
     end
  ---- rendezs 
   
   commit
    select @rgznaploid as rgznaplo,@rgzneve as nev,  0 as hiba,'OK' as hibaszov,@szszam as szszam,@szamlaID as szamlaID,@tetelfejID as tetelfejid
  
 end try 
 begin catch
   rollback tran
   select 0 as rgznaplo,'' as nev,Error_number() as hiba,Error_message() as hibaszov,'' as szszam,0 as szamlaID,0 as tetelfejID
   return 
end catch
end