create  procedure [dbo].[sp_szla_kiegyen]
 @szamlaid int,@fizmodID tinyint,@bizszam varchar(16) = null,@creuser smallint
as
begin
 declare @bkjel char(1),@irany char(1),@naplotip char(1),@naplokod char(1),@naploid int,@jogcimkod varchar(6),@jogcimid int,@bizszov varchar(30),@konyvev tinyint,@tetelfejid int,@szsz char(8)
 declare @bizkelt date,@rgzid int,@rgzneve varchar(20),@szszid int,@eszszid int,@bbizszam varchar(12),@vevoid int,@brutto money,@szlahiv varchar(12),@uzemekID tinyint,@hatralek money
 SET NOCOUNT ON;

SET DEADLOCK_PRIORITY HIGH; 

 select @szlahiv=szszam,@vevoid=fizeto,@brutto=brutto,@hatralek=hatralek,@tetelfejid=tetelfejID from szamlak where szamlaid=@szamlaid
 if @vevoid is null
   begin
    select -1 as hiba,'Nincs ilyen szmla' as hibaszov
    return
 end
 if @hatralek=0
   begin
    select -5 as hiba,'Mr kiegyenltett' as hibaszov
    return
  end

 set @bizkelt=getdate()
 select @konyvev=evekID from evek where year(getdate())=ev
 if @konyvev is null
   begin
    select -2 as hiba,'Nincs ilyen knyvelsi v' as hibaszov
    return
 end
 if @fizmodID=1
   begin
     set @naplotip=left(dbo.fc_usetup(23,@creuser),1)
     set @naplokod=left(dbo.fc_usetup(21,@creuser),1)
     set @jogcimkod=dbo.fc_usetup(22,@creuser)
   end
 else
   begin
     set @naplotip='X'
     set @naplokod=left(dbo.fc_setup('R',@konyvev,99),1)
     set @jogcimkod=dbo.fc_setup('R',@konyvev,100)
   end

 
 select @jogcimID=jogcimID, @bizszov=szoveg,@irany=irany from jogcim where konyvev=@konyvev and jogcimkod=@jogcimkod
    
  if @jogcimID is null
   begin
    select -3 as hiba,'Nincs ilyen jogcm' as hibaszov
    return
   end
 select @naploID=naploID from naplofej where konyvev=@konyvev and naplotip=@naplotip and bkod=@naplokod and zarva='N'
 if @naploID is null
   begin
    select -4 as hiba,'Nincs ilyen napl' as hibaszov
    return
   end

begin try
 begin tran

 select @szsz=sztukor.szsz,@uzemekid=tetelsor.uzemekid from tetelsor left join sztukor on tetelsor.szszid=sztukor.sztukorid where tetelfejid=@tetelfejid and @szamlaid=szamlaid and sorszam=1
 select @szszid=sztukor.sztukorid from sztukor where @szsz=szsz and @konyvev=KOnyvev
 select  @rgzID=rgzID,@rgzneve=rgzneve from RGZNAPLO where NaploID=@naploID and Zart='N'
 if @rgzID is null
        begin
          select @rgzneve=naplofej.naplotip+naplofej.bkod+right(rtrim(evek.Ev),2)+'-'+right('00'+ltrim(str(month(@bizkelt),2)),2)+'-'+right('000'+ltrim(str(naplofej.RgzSorszam,3)),3)
           from naplofej
              left join evek on naplofej.KonyvEv=evek.evekID
              where naploID=@naploID
  
          insert into RGZNAPLO (NaploID,creUser,Neve,Zart,rgzneve)
                values (@naploID,@creUser,'','N',@rgzneve)
          select @rgzid=@@identity 
        end
      
  --update naplofej set sorszam=sorszam+1 where naploID=@naploID
 set @bkjel='0'
	  if rtrim(dbo.fc_setup('R',@konyvev,182))='Igen'
               begin
		               
		 set @bkjel='K'
                 if @irany='N'
                   set @bkjel='B'  
               end  
	   if @bkjel='0' or @bkjel='K'	               
		update naplofej set sorszam=sorszam+1 where naploID=@naploID
	   if @bkjel='B'	
               update naplofej set sorszamb=isnull(sorszamb,0)+1 where naploID=@naploID





  select @eszszID=NAPLOFEJ.Fszsz,@bbizszam=naplofej.naplotip+naplofej.bkod+right(rtrim(evek.Ev),2)+'-'+@bkjel+right('00000'+ltrim(str((case when @bkjel='B' then sorszamb else sorszam end),naplofej.bizhosz)),naplofej.bizhosz)
           from naplofej  left join evek on evek.evekid=naplofej.konyvev where naploID=@naploID

          
  insert into tetelfej (naploID,bizkelt,ekelt,bbizszam,Bizszam,CreUser,tetelszam,KonyvEv,Naplotip,RgzID  ) 
             values(@naploID,@bizkelt,@bizkelt,@bbizszam,@Bizszam,@creUser,0,@KonyvEv,@naplotip,@rgzID)
  select @tetelfejID=@@identity  
  insert into tetelsor (tetelfejID,vevoid,szamlaid,SzszID,eszszID,osszeg,tkjel,Tartozik,AfaOsszeg,kvjel,sorszam,Bizszov,fizmodid,jogcimID,szlahiv,bkelt,uzemekid) 
      values (@tetelfejID,@vevoid,@szamlaid,@eszszID,@szszID,@hatralek,'True',@hatralek,0,'A',1,@bizszov,@fizmodid,@jogcimID,@szlahiv,@bizkelt,@uzemekid)
  commit
  exec sp_szamla_egyen @szamlaID
  create table #h2 (hiba int,hibaszov varchar(100))
   insert into #h2 exec sp_konyvel @tetelfejid
   --select @hiba=hiba from #h2
   drop table #h2
  select 0 as hiba,'OK' as hibaszov,@bbizszam as bbizszam
end try 
 begin catch
   rollback tran
   select Error_number() as hiba,Error_message() as hibaszov,'' as bbizszam
   return 
end catch

end