CREATE TRIGGER [dbo].[tr_akcio_modify2] ON [dbo].[AKCIO] FOR UPDATE
AS
DECLARE @userID smallint

--Digitlis cmke user azonost
SELECT @userID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 228

IF @userID = ''
	RETURN

DECLARE @vonalkodID int, @akcioID smallint, @tol date, @ig date, @telepID tinyint,

		@dTol date, @dIg date, @dTelepID tinyint

SELECT @akcioID=AkcioID, @tol=Tol, @ig=Ig, @telepID=TelepID FROM inserted

SELECT @dTol=Tol, @dIg=Ig, @dTelepID=TelepID FROM deleted

--Ha nem vltozott az tadott rtkek valamelyike
IF @tol = @dTol AND @ig = @dIg AND @telepID = @dTelepID
	RETURN

--Akci tl-ig most nem mai napi, de eddig sem volt vagy akci tol-ig mai s ezutn is vagy nem rint res vagy 1-es telepet
IF (CAST(GETDATE() AS DATE) NOT BETWEEN @tol AND @ig AND CAST(GETDATE() AS DATE) NOT BETWEEN @dTol AND @dIg) OR (CAST(GETDATE() AS DATE) BETWEEN @tol AND @ig AND CAST(GETDATE() AS DATE) BETWEEN @dTol AND @dIg) OR (ISNULL(@telepID,1) <> 1 AND ISNULL(@dTelepID,1) <> 1)
	RETURN

DECLARE VonalkodCursor CURSOR FOR

	SELECT VONALKOD.VonalkodID
	FROM VONALKOD
		 INNER JOIN CIKK ON CIKK.CikkID = VONALKOD.CikkID
		 INNER JOIN CIKKAKC ON CIKKAKC.CikkID = CIKK.CikkID
	WHERE CIKKAKC.AkcioID = @akcioID

OPEN VonalkodCursor

FETCH NEXT FROM VonalkodCursor INTO @vonalkodID

WHILE @@FETCH_STATUS = 0
BEGIN

	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32),@vonalkodID,@userID)

	FETCH NEXT FROM VonalkodCursor INTO @vonalkodID
END

CLOSE VonalkodCursor
DEALLOCATE VonalkodCursor