CREATE TRIGGER [dbo].[tr_arajvsor_insert] ON [dbo].[ARAJVSOR] 
FOR INSERT, UPDATE
AS

DECLARE @arajvfejID int, @netto money, @tetelszam smallint, @afa money, @kedvezF numeric (5,2), @szlaRound tinyint

SELECT @arajvfejID=arajvfejID FROM inserted

SELECT @kedvezf=ARAJVFEJ.Kedvezmeny, @szlaRound=DEVIZA.SzlaRound
FROM ARAJVFEJ
	 INNER JOIN DEVIZA ON DEVIZA.DevizaID = ARAJVFEJ.DevizaID
WHERE ARAJVFEJ.Arajvfejid=@arajvfejID

SELECT @netto=SUM(ISNULL(ARAJVSOR.Egysegar,0) * ARAJVSOR.Mennyi), 
       @afa=SUM(ISNULL(ARAJVSOR.Egysegar,0) * ARAJVSOR.Mennyi * (AFAK.Szaz/100)),
       @tetelszam=COUNT(ARAJVSOR.ArajVFejID)
FROM ARAJVSOR
     LEFT JOIN AFAK ON ARAJVSOR.Afaid=AFAK.AfaID 
WHERE ARAJVSOR.ArajVFejID=@arajvfejID

SET @kedvezF=ISNULL(@kedvezF,0)
SET @netto=ISNULL(@netto,0)
SET @afa=ISNULL(@afa,0)
SET @tetelszam=ISNULL(@tetelszam,0)

SET @netto=ROUND(@netto * (100-@kedvezF)/100, @szlaRound)
SET @afa=ROUND(@afa * (100-@kedvezF)/100, @szlaRound)

UPDATE ARAJVFEJ SET Netto=@netto, Tetelszam=@tetelszam, Brutto=@netto + @afa WHERE Arajvfejid=@arajvfejID