CREATE TRIGGER [dbo].[tr_arlista_modify] ON [dbo].[ARLISTA] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'FLEX') = 0
	RETURN

DECLARE @arlistaID tinyint, @devizaID tinyint,

		@dArlistaID tinyint, @dDevizaID tinyint,

		@gcmMuvInt int

SELECT @arlistaID=ArlistaID, @devizaID=DevizaID FROM inserted

SELECT @dArlistaID=ArlistaID, @dDevizaID=DevizaID FROM deleted

--j vagy mdosts
IF @arlistaID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 101 --rlista letlts

	--Mdosts
	IF @dArlistaID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @devizaID = @dDevizaID
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 102 --rlista trls
	SET @arlistaID = @dArlistaID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @arlistaID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 101)
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@arlistaID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@arlistaID,@webUserID2)