CREATE TRIGGER [dbo].[tr_cikkacsm_modify] ON [dbo].[CIKKACSM] FOR INSERT,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @cikkAcsmID int,

		@dCikkAcsmID int,

		@gcmMuvInt int

SELECT @cikkAcsmID=CikkAcsmID FROM inserted

SELECT @dCikkAcsmID=CikkAcsmID FROM deleted

IF @cikkAcsmID IS NULL AND @dCikkAcsmID IS NULL
	RETURN

--j
IF @cikkAcsmID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 86 --ltalnos cikkcsoport mtrix letlts

END
ELSE IF @dCikkAcsmID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 87 --ltalnos cikkcsoport mtrix trls
	SET @cikkAcsmID = @dCikkAcsmID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkAcsmID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 86) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkAcsmID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 86) AND UserID = @webUserID2
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkAcsmID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkAcsmID,@webUserID2)