CREATE TRIGGER [dbo].[tr_cikkacss_modify] ON [dbo].[CIKKACSS] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @cikkacssID int, @cikkID int,

		@dCikkacssID int, @dCikkID int,

		@gcmMuvInt int

SELECT @cikkacssID=CikkacssID, @cikkID=CikkID FROM inserted

SELECT @dCikkacssID=CikkacssID, @dCikkID=CikkID FROM deleted

--j vagy mdosts
IF @cikkacssID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 78 --ltalnos cikkcsoport cikk letlts

	--Mdosts
	IF @dCikkacssID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @cikkID = @dCikkID
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 79 --ltalnos cikkcsoport cikk trls
	SET @cikkacssID = @dCikkacssID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkacssID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 78) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkacssID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 78) AND UserID = @webUserID2
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkacssID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkacssID,@webUserID2)