CREATE TRIGGER [dbo].[tr_cikkakc_modify] ON [dbo].[CIKKAKC] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod IN('KHG','FLEX')) > 0
	RETURN

DECLARE @cikkAkcID int, @akcioID smallint, @cikkID int, @egysegAr money, @egysarArB money,

		@dCikkAkcID int, @dAkcioID smallint, @dCikkID int, @dEgysegAr money, @dEgysarArB money,

		@gcmMuvInt int

SELECT @cikkAkcID=CikkAkcID, @akcioID=AkcioID, @cikkID=CikkID, @egysegAr=EgysegAr, @egysarArB=EgysarArb FROM inserted

SELECT @dCikkAkcID=CikkAkcID, @dAkcioID=AkcioID, @dCikkID=CikkID, @dEgysegAr=EgysegAr, @dEgysarArB=EgysarArb FROM deleted

--j vagy mdosts
IF @cikkAkcID IS NOT NULL
BEGIN
	--Nem telepfgg akci
	IF (SELECT COUNT(*) FROM AKCIO WHERE AkcioID = @akcioID AND TelepID IS NULL) = 0
		RETURN

	SET @gcmMuvInt = 58 --Cikk akci letlts

	--Mdosts
	IF @dCikkAkcID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @cikkID = @dCikkID AND @egysegAr = @dEgysegAr AND @egysarArB = @dEgysarArB
			RETURN

	END
END
ELSE
BEGIN
	--Nem telepfgg akci
	IF (SELECT COUNT(*) FROM AKCIO WHERE AkcioID = @dAkcioID AND TelepID IS NULL) = 0
		RETURN

	SET @gcmMuvInt = 59 --Cikk akci trls
	SET @cikkAkcID = @dCikkAkcID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkAkcID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 58) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkAkcID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 58) AND UserID = @webUserID2
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkAkcID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkAkcID,@webUserID2)