CREATE TRIGGER [dbo].[tr_cikkcons_modify] ON [dbo].[CIKKCONS] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @cikkConsID int, @cikConLe varchar(50), @cikkConME varchar(10),

		@dCikkConsID int, @dCikConLe varchar(50), @dCikkConME varchar(10),

		@gcmMuvInt int

SELECT @cikkConsID=CikkconsID, @cikConLe=CikkconLe, @cikkConME=CikkconME FROM inserted

SELECT @dCikkConsID=CikkconsID, @dCikConLe=CikkconLe, @dCikkConME=CikkconME FROM deleted

--j vagy mdosts
IF @cikkConsID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 44 --Cikk lers letlts

	--Mdosts
	IF @dCikkConsID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @cikConLe = @dCikConLe AND @cikkConME = @dCikkConME
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 45 --Cikk lers trls
	SET @cikkConsID = @dCikkConsID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkConsID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 44) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkConsID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 44) AND UserID = @webUserID2
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkConsID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkConsID,@webUserID2)