CREATE TRIGGER [dbo].[tr_cikkkapc_modify] ON [dbo].[CIKKKAPC] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @cikkkapcID int, @alCikkID int,

		@dCikkkapcID int, @dAlCikkID int,

		@gcmMuvInt int

SELECT @cikkkapcID=CikkkapcID, @alCikkID=AlCikkID FROM inserted

SELECT @dCikkkapcID=CikkkapcID, @dAlCikkID=AlCikkID FROM deleted

--j vagy mdosts
IF @cikkkapcID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 50 --Kompatibilis cikk letlts

	--Mdosts
	IF @dCikkkapcID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @alCikkID = @dAlCikkID
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 51 --Kompatibilis cikk trls
	SET @cikkkapcID = @dCikkkapcID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkkapcID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 50) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkkapcID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 50) AND UserID = @webUserID2
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkkapcID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkkapcID,@webUserID2)