CREATE TRIGGER [dbo].[tr_cikkvedd_modify] ON [dbo].[CIKKVEDD] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @cikkVeddID int, @cikkID2 int,

		@dCikkVeddID int, @dCikkID2 int,

		@gcmMuvInt int

SELECT @cikkVeddID=CikkVeddID, @cikkID2=CikkID2 FROM inserted

SELECT @dCikkVeddID=CikkVeddID, @dCikkID2=CikkID2 FROM deleted

--j vagy mdosts
IF @cikkVeddID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 54 --Javasolt cikk letlts

	--Mdosts
	IF @dCikkVeddID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @cikkID2 = @dCikkID2
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 55 --Javasolt cikk trls
	SET @cikkVeddID = @dCikkVeddID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkVeddID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 54) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkVeddID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 54) AND UserID = @webUserID2
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkVeddID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkVeddID,@webUserID2)