create TRIGGER tr_fordasor_insert ON FORDASOR
FOR INSERT,update,delete
AS

DECLARE @fordafejid int, @tavolsag numeric (10,1),@ido smallint,@rezsikm numeric (10,1),@db int,@dbr int,@vezetIdo smallint
declare @specjel char(1),@jaratDb tinyint,@fordasorID int,@specjel_old char(1)
BEGIN TRY
begin tran
	SELECT @fordafejid = fordafejid,@fordasorid=fordasorid,@specjel_old=isnull(specjel,' ') FROM deleted	
	if @@ROWCOUNT=0
      		SELECT @fordafejid = fordafejid,@fordasorid=fordasorid, @specjel_old=' '  FROM inserted
        if @specjel_old>' '
  		delete from fordakiv where fordafejid=@fordafejid and specjel=@specjel_old
	select @tavolsag=isnull(SUM(tavolsag),0),@ido=isnull(sum(ido),0),@db=COUNT(*) from FORDASOR where FordafejID=@fordafejid
	select @rezsikm=isnull(SUM(tavolsag),0),@dbr=COUNT(*) from FORDASOR left join MENETJAR on menetjar.jaratid=fordasor.jaratid
	  where FordafejID=@fordafejid and left(MENETJAR.jaratkod,1)='R'
    set @vezetIdo=@ido-(@db-@dbr)*2
	UPDATE fordafej  SET jaratkm=@tavolsag,JaratIdo=@ido,rezsikm=@rezsikm,VezetIdo=@vezetIdo where fordafejid=@fordafejid

	if CURSOR_STATUS('global','Tpsor')>=-1
	begin     
		close Tpsor
		deallocate Tpsor
	end
   declare Tpsor cursor for
   select specjel  COLLATE SQL_Latin1_General_CP1_CS_AS,isnull(SUM(tavolsag),0) as tavolsag,isnull(SUM(ido),0) as ido,
   isnull(SUM( case when left(MENETJAR.jaratkod,1)='R' then tavolsag else 0 end),0)  as rezsikm,COUNT(*) as JaratDb
    from FORDASOR  left join MENETJAR on menetjar.jaratid=fordasor.jaratid where FordafejID=@fordafejid and SpecJel<>'-' group by SpecJel  COLLATE SQL_Latin1_General_CP1_CS_AS
   open tpsor
   fetch tpsor into @specjel,@tavolsag,@ido,@rezsikm,@jaratDb
    while @@Fetch_status=0
    begin
	 select * from fordakiv where fordafejid=@fordafejid and specjel=@specjel
	 if @@ROWCOUNT=0
	    insert into fordakiv (fordafejid,specjel,jaratido,jaratkm,rezsikm,JaratDb) values (@fordafejid,@specjel,0,0,0,0)
         update fordakiv set jaratido=@ido,jaratkm=@tavolsag,RezsiKm=@rezsikm,JaratDb=@jaratDB where fordafejid=@fordafejid and specjel=@specjel
	 fetch tpsor into @specjel,@tavolsag,@ido,@rezsikm,@JaratDb
	end
    close Tpsor
    deallocate Tpsor
 commit
END TRY


BEGIN CATCH
	ROLLBACK TRANSACTION
END CATCH