CREATE TRIGGER [dbo].[tr_keszlet_modify2] ON [dbo].[KESZLET] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID2 smallint

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @keszletID int, @raktarID tinyint, @cikkID int, @mennyi decimal(11,3), @foglalt decimal(10,3),

		@dKeszletID int, @dRaktarID tinyint, @dCikkID int, @dMennyi decimal(11,3), @dFoglalt decimal(10,3),

		@gcmMuvInt int, @histID int

SELECT @keszletID=KeszletID, @raktarID=RaktarID, @cikkID=CikkID, @mennyi=Mennyi, @foglalt=Foglalt FROM inserted

SELECT @dKeszletID=KeszletID, @dRaktarID=RaktarID, @dCikkID=CikkID, @dMennyi=Mennyi, @dFoglalt=Foglalt FROM deleted

--j vagy mdosts
IF @keszletID IS NOT NULL
BEGIN

	--(Megsznt vagy nem webshopos raktr) 
	IF ((SELECT COUNT(*) FROM RAKTAR WHERE RaktarID = @raktarID AND (ISNULL(Megszunt,0) = 1 OR ISNULL(WebShop,0) = 0)) = 1)
		RETURN

	--nem megsznt s webshop
	IF ((SELECT COUNT(*) FROM CIKK WHERE CikkID = @cikkID AND ISNULL(Megszunt,0) = 0 AND Cikkhiercs IS NOT NULL AND Webre2 = 1) = 0)
		RETURN

	SET @gcmMuvInt = 62 --Kszlet letlts

	--Mdosts
	IF @dKeszletID IS NOT NULL
	BEGIN

		--Flex-Fnynl a foglalt mennyisget is kszlet vltozsnak kell venni
		IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'FLEX') > 0
		BEGIN
			--ha nem vltozott az tadott rtkek valamelyike
			IF @mennyi - ISNULL(@foglalt,0) = @dMennyi - ISNULL(@dFoglalt,0)
				RETURN
		END
		ELSE
		BEGIN
			--ha nem vltozott az tadott rtkek valamelyike
			IF @mennyi = @dMennyi
				RETURN
		END
	END
END
ELSE
BEGIN
	--TODO BUG, GCMSYNC bejegyzett kszlet trlst NULL RekordID-vel 2x majd ezt kveten kszlet letlts
	RETURN

	--(Megsznt vagy nem webshopos raktr) vagy (megsznt vagy nem webshop cikk) esetn nem kell kikldeni
	IF ((SELECT COUNT(*) FROM RAKTAR WHERE RaktarID = @dRaktarID AND (ISNULL(Megszunt,0) = 1 OR ISNULL(WebShop,0) = 0)) = 1) OR ((SELECT COUNT(*) FROM CIKK WHERE CikkID = @dCikkID AND (ISNULL(Megszunt,0) = 1 OR ISNULL(Webre2,0) = 0 OR Cikkhiercs IS NULL)) = 1)
		RETURN

	SET @gcmMuvInt = 63 --Kszlet trls
	SET @keszletID = @dKeszletID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @keszletID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 62)
END

INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@keszletID,@webUserID2)