create TRIGGER [dbo].[tr_naptar_insert] ON [dbo].[NAPTAR]
FOR INSERT, UPDATE, DELETE
AS 
BEGIN
BEGIN TRY
	DECLARE 
	@naptarID int, @mutato int, @mutatoTip tinyint, @szemelyID smallint,@SpecKod char(1),
	@dNaptarID int, @dMutato int, @dMutatoTip tinyint, @dSzemelyID smallint,@dSpeckod char(1),
	
	--GCM klds
	@userID smallint, @gcmMuvID int, @gcmMuvInt int

	SELECT @naptarID = NaptarID, @mutato = Mutato, @mutatoTip = MutatoTip, @szemelyID = SzemelyID, @Speckod=Speckod FROM inserted 
	  left join EBTEVEKE on EBTEVEKE.EbTevekeID=inserted.mutatotip
	SELECT @dNaptarID = NaptarID, @dmutato = Mutato, @dMutatoTip = MutatoTip, @dSzemelyID = SzemelyID, @dSpeckod=Speckod FROM deleted
	  left join EBTEVEKE on EBTEVEKE.EbTevekeID=deleted.mutatotip
	SELECT @userID = UserID FROM USERS WHERE SzemelyID = ISNULL(@szemelyID, @dSzemelyID) AND SyncInterv IS NOT NULL

	BEGIN TRAN

	IF @naptarID IS NOT NULL
	BEGIN
		IF @dNaptarID IS NULL
		BEGIN
			--IF @mutatoTip = 2
			if @Speckod='E'
			BEGIN
				SET @gcmMuvInt = 5 -- j ellenrzs

				--Ha mr zrt
				IF (SELECT COUNT(*) FROM FOGYHELL WHERE FogyHEllID = @mutato AND (Lezarva IS NOT NULL OR ISNULL(Lezart,0) = 1)) = 1
				BEGIN
					COMMIT
					RETURN
				END

				--Ha felhasznlhoz van ktve
				IF @userID IS NOT NULL
				BEGIN
					--Ellenrzs munki ltrehozsa a felhasznlhoz
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, FogyHEllID)
					SELECT (SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 14), FogyhelsID, @userID, fogyhellID
					FROM FOGYHELS
					WHERE fogyhellID = @mutato AND NOT EXISTS (
						SELECT GCMSYNC.GCMSyncID
						FROM GCMSYNC
								INNER JOIN gcmmuv ON gcmmuv.GCMmuvID = GCMSYNC.GCMMuvID
						WHERE gcmmuv.GCMmuvInt = 14 AND GCMSYNC.FogyHEllID = FOGYHELS.fogyhellID AND GCMSYNC.UserID = @userID AND ISNULL(GCMSYNC.Zart, 0) = 0)
				END
			END
			--ELSE IF @mutatoTip = 3
			Else IF @Speckod=''
			BEGIN
				SET @gcmMuvInt = 8 -- j racsere

				--Ha mr zrt
				IF (SELECT COUNT(*) FROM OCSEREER WHERE OcsereerID = @mutato AND (Lezarva IS NOT NULL OR ISNULL(Lezart,0) = 1)) = 1
				BEGIN
					COMMIT
					RETURN
				END

				--Ha felhasznlhoz van ktve
				IF @userID IS NOT NULL
				BEGIN
					--racsere sorok ltrehozsa a felhasznlhoz
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, OcsereerID)
					SELECT (SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 24), OcsereesID, @userID, OcsereerID
					FROM OCSEREES
					WHERE OcsereerID = @mutato AND NOT EXISTS (
						SELECT GCMSYNC.GCMSyncID
						FROM GCMSYNC
								INNER JOIN gcmmuv ON gcmmuv.GCMmuvID = GCMSYNC.GCMMuvID
						WHERE gcmmuv.GCMmuvInt = 24 AND GCMSYNC.OcsereerID = OCSEREES.OcsereerID AND GCMSYNC.UserID = @userID AND ISNULL(GCMSYNC.Zart, 0) = 0)
				END
			END
			ELSE
			BEGIN
				COMMIT
				RETURN
			END
		END
		ELSE
		BEGIN
			--IF @mutatoTip = 2
			If @Speckod='E'
			BEGIN

				--Ha mr zrt
				IF (SELECT COUNT(*) FROM FOGYHELL WHERE FogyHEllID = @mutato AND (Lezarva IS NOT NULL OR ISNULL(Lezart,0) = 1)) = 1
				BEGIN
					COMMIT
					RETURN
				END

				--Ellenrzs thelyezs esetn, ha vltozik a szemly
				IF @szemelyID <> @dSzemelyID
				BEGIN
					--Ellenrzs munki trlse
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, FogyHEllID)
					SELECT (SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 15), RekordID, UserID, FogyHEllID
					FROM GCMSYNC
						 INNER JOIN gcmmuv ON gcmmuv.GCMmuvID = GCMSYNC.GCMMuvID
					WHERE gcmmuv.GCMmuvInt = 14 AND GCMSYNC.FogyHEllID = @mutato AND ISNULL(GCMSYNC.Zart, 0) = 0
					GROUP BY RekordID, UserID, FogyHEllID

					--Ellenrzs trlse
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, FogyHEllID)
					SELECT (SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 7), RekordID, UserID, FogyHEllID
					FROM GCMSYNC
						 INNER JOIN gcmmuv ON gcmmuv.GCMmuvID = GCMSYNC.GCMMuvID
					WHERE gcmmuv.GCMmuvInt IN (5,6) AND GCMSYNC.FogyHEllID = @mutato AND ISNULL(GCMSYNC.Zart, 0) = 0
					GROUP BY RekordID, UserID, FogyHEllID

					--Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
					UPDATE GCMSYNC SET Zart = 1 WHERE FogyHEllID = @mutato AND (GCMMuvID NOT IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt IN (7,15)) OR UserID = ISNULL(@userID, 0))

					--Ha nincs felhasznlhoz ktve
					IF @userID IS NULL
					BEGIN
						COMMIT
						RETURN
					END

					--Ellenrzs munki ltrehozsa a felhasznlhoz
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, FogyHEllID)
					SELECT (SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 14), FogyhelsID, @userID, fogyhellID
					FROM FOGYHELS
					WHERE fogyhellID = @mutato AND NOT EXISTS (
						SELECT GCMSYNC.GCMSyncID
						FROM GCMSYNC
								INNER JOIN gcmmuv ON gcmmuv.GCMmuvID = GCMSYNC.GCMMuvID
						WHERE gcmmuv.GCMmuvInt = 14 AND GCMSYNC.FogyHEllID = FOGYHELS.fogyhellID AND GCMSYNC.UserID = @userID AND ISNULL(GCMSYNC.Zart, 0) = 0)

					--j ellenrzs
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, FogyHEllID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 5), @mutato, @userID, @mutato)

					COMMIT
					RETURN
				END
				
				SET @gcmMuvInt = 6 -- Ellenrzs mdosts

				--Ha felhasznlhoz van ktve (meghisulst kveten, zrt sorok jranyitsa)
				IF @userID IS NOT NULL
				BEGIN
					--Ellenrzs munki ltrehozsa a felhasznlhoz
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, FogyHEllID)
					SELECT (SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 14), FogyhelsID, @userID, fogyhellID
					FROM FOGYHELS
					WHERE fogyhellID = @mutato AND NOT EXISTS (
						SELECT GCMSYNC.GCMSyncID
						FROM GCMSYNC
								INNER JOIN gcmmuv ON gcmmuv.GCMmuvID = GCMSYNC.GCMMuvID
						WHERE gcmmuv.GCMmuvInt = 14 AND GCMSYNC.FogyHEllID = FOGYHELS.fogyhellID AND GCMSYNC.UserID = @userID AND ISNULL(GCMSYNC.Zart, 0) = 0)
				END
			END
			--ELSE IF @mutatoTip = 3
			ELSE IF @SpecKod=''
			BEGIN

				--Ha mr zrt
				IF (SELECT COUNT(*) FROM OCSEREER WHERE OcsereerID = @mutato AND (Lezarva IS NOT NULL OR ISNULL(Lezart,0) = 1)) = 1
				BEGIN
					COMMIT
					RETURN
				END

				--racsere thelyezs esetn, ha vltozik a szemly, racsere sorok thelyezse
				IF @szemelyID <> @dSzemelyID
				BEGIN
					--racsere sorok trlse
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, OcsereerID)
					SELECT (SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 25), RekordID, UserID, OcsereerID
					FROM GCMSYNC
						 INNER JOIN gcmmuv ON gcmmuv.GCMmuvID = GCMSYNC.GCMMuvID
					WHERE gcmmuv.GCMmuvInt = 24 AND GCMSYNC.OcsereerID = @mutato AND ISNULL(GCMSYNC.Zart, 0) = 0
					GROUP BY RekordID, UserID, OcsereerID

					--racsere trlse
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, OcsereerID)
					SELECT (SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 10), RekordID, UserID, OcsereerID
					FROM GCMSYNC
						 INNER JOIN gcmmuv ON gcmmuv.GCMmuvID = GCMSYNC.GCMMuvID
					WHERE gcmmuv.GCMmuvInt IN (8,9) AND GCMSYNC.OcsereerID = @mutato AND ISNULL(GCMSYNC.Zart, 0) = 0
					GROUP BY RekordID, UserID, OcsereerID

					--Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
					UPDATE GCMSYNC SET Zart = 1 WHERE OcsereerID = @mutato AND (GCMMuvID NOT IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt IN (10,25)) OR UserID = ISNULL(@userID, 0))

					--Ha nincs felhasznlhoz ktve
					IF @userID IS NULL
					BEGIN
						COMMIT
						RETURN
					END

					--racsere sorok ltrehozsa a felhasznlhoz
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, OcsereerID)
					SELECT (SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 24), OcsereesID, @userID, OcsereerID
					FROM OCSEREES
					WHERE OcsereerID = @mutato AND NOT EXISTS (
						SELECT GCMSYNC.GCMSyncID
						FROM GCMSYNC
								INNER JOIN gcmmuv ON gcmmuv.GCMmuvID = GCMSYNC.GCMMuvID
						WHERE gcmmuv.GCMmuvInt = 24 AND GCMSYNC.OcsereerID = OCSEREES.OcsereerID AND GCMSYNC.UserID = @userID AND ISNULL(GCMSYNC.Zart, 0) = 0)

					--j racsere
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, OcsereerID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 8), @mutato, @userID, @mutato)

					COMMIT
					RETURN
				END

				SET @gcmMuvInt = 9 -- racsere mdosts

				--Ha felhasznlhoz van ktve (meghisulst kveten, zrt sorok jranyitsa)
				IF @userID IS NOT NULL
				BEGIN
					--racsere sorok ltrehozsa a felhasznlhoz
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, OcsereerID)
					SELECT (SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 24), OcsereesID, @userID, OcsereerID
					FROM OCSEREES
					WHERE OcsereerID = @mutato AND NOT EXISTS (
						SELECT GCMSYNC.GCMSyncID
						FROM GCMSYNC
								INNER JOIN gcmmuv ON gcmmuv.GCMmuvID = GCMSYNC.GCMMuvID
						WHERE gcmmuv.GCMmuvInt = 24 AND GCMSYNC.OcsereerID = OCSEREES.OcsereerID AND GCMSYNC.UserID = @userID AND ISNULL(GCMSYNC.Zart, 0) = 0)
				END
			END
			ELSE
			BEGIN
				COMMIT
				RETURN
			END
		END
	END
	ELSE
	BEGIN
		SET @naptarID = @dNaptarID
		SET @szemelyID = @dSzemelyID
		SET @mutato = @dMutato
		SET @mutatoTip = @dMutatoTip;
		Set @Speckod=@dSpeckod
		--IF @dMutatoTip = 2
		IF @dSpeckod='E'
		BEGIN

			--Ha mr zrt
			IF (SELECT COUNT(*) FROM FOGYHELL WHERE FogyHEllID = @mutato AND (Lezarva IS NOT NULL OR ISNULL(Lezart,0) = 1)) = 1
			BEGIN
				COMMIT
				RETURN
			END

			SET @gcmMuvInt = 7 -- Ellenrzs trls

			--Ellenrzs munki trlse
			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, FogyHEllID)
			SELECT (SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 15), RekordID, UserID, FogyHEllID
			FROM GCMSYNC
				 INNER JOIN gcmmuv ON gcmmuv.GCMmuvID = GCMSYNC.GCMMuvID
			WHERE gcmmuv.GCMmuvInt = 14 AND GCMSYNC.FogyHEllID = @mutato AND ISNULL(GCMSYNC.Zart, 0) = 0

			-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
			UPDATE GCMSYNC SET Zart = 1 WHERE FogyHEllID = @mutato AND GCMMuvID NOT IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt IN (7,15))
		END
		--ELSE IF @dMutatoTip = 3
		ELSE IF @dSpeckod=''
		BEGIN

			--Ha mr zrt
			IF (SELECT COUNT(*) FROM OCSEREER WHERE OcsereerID = @mutato AND (Lezarva IS NOT NULL OR ISNULL(Lezart,0) = 1)) = 1
			BEGIN
				COMMIT
				RETURN
			END

			SET @gcmMuvInt = 10 -- racsere trls

			--racsere sorok trlse
			INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, OcsereerID)
			SELECT (SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 25), RekordID, UserID, OcsereerID
			FROM GCMSYNC
			     INNER JOIN gcmmuv ON gcmmuv.GCMmuvID = GCMSYNC.GCMMuvID
			WHERE gcmmuv.GCMmuvInt = 24 AND GCMSYNC.OcsereerID = @mutato AND ISNULL(GCMSYNC.Zart, 0) = 0

			-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
			UPDATE GCMSYNC SET Zart = 1 WHERE OcsereerID = @mutato AND GCMMuvID NOT IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt IN (10,25))
		END
		ELSE
		BEGIN
			COMMIT
			RETURN
		END
	END

	--Ha nincs felhasznlhoz ktve
	IF @userID IS NULL
	BEGIN
		COMMIT
		RETURN
	END

	SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt

	--INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, FogyHEllID, OcsereerID) VALUES (@gcmMuvID, @mutato, @userID, (CASE WHEN @mutatoTip = 2 THEN @mutato ELSE NULL END), (CASE WHEN @mutatoTip = 3 THEN @mutato ELSE NULL END))
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, FogyHEllID, OcsereerID) VALUES (@gcmMuvID, @mutato, @userID, (CASE WHEN @SpecKod = 'E' THEN @mutato ELSE NULL END), (CASE WHEN @Speckod='' THEN @mutato ELSE NULL END))

	COMMIT

END TRY
BEGIN CATCH
	ROLLBACK
END CATCH
END