CREATE TRIGGER [dbo].[tr_psztetel_update] ON [dbo].[PSZTETEL] 
FOR UPDATE
AS

DECLARE @szamlaID int, @szszam varchar(12), @pSzszam varchar(12), @sztetelID int, @dSztetelID int

SELECT @szamlaID=SZAMLAK.Szamlaid, @pSzszam=PSZAMLAK.Szszam, @sztetelID=inserted.SztetelID, @szszam=SZAMLAK.Szszam
FROM inserted
	 INNER JOIN PSZAMLAK ON PSZAMLAK.PszamlaID = inserted.PszamlaID
	 LEFT JOIN SZTETEL ON SZTETEL.SztetelID = inserted.SztetelID
	 LEFT JOIN SZAMLAK ON SZAMLAK.SzamlaID = SZTETEL.SzamlaID
WHERE PSZAMLAK.Szamlaid IS NULL

SELECT @dSztetelID=SztetelID FROM deleted

--Proforma szmla szmlzva
IF @dSztetelID IS NULL AND @sztetelID IS NOT NULL
BEGIN

	UPDATE TETELSOR SET Szlahiv=@szszam, SzamlaID=@szamlaID WHERE Szlahiv=@pSzszam AND SzamlaID IS NULL

	exec sp_szamla_egyen @szamlaID
END