CREATE TRIGGER [dbo].[tr_szallito_insert2] ON [dbo].[SZALLITO] FOR INSERT
AS
DECLARE @szallitoID int, @hossz tinyint, @szkod varchar(8)

SELECT @szallitoID=SzallitoID FROM inserted WHERE ISNULL(LTRIM(RTRIM(Szkod)),'') = ''

IF @szallitoID IS NOT NULL
BEGIN
	--Szllt kd hossza
	SELECT @hossz = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 15
	SET @szkod = RIGHT(REPLICATE('0',@hossz-1) + CAST(@szallitoID AS varchar),@hossz)

	IF (SELECT COUNT(*) FROM SZALLITO WHERE LTRIM(RTRIM(Szkod)) = @szkod) = 0
		UPDATE SZALLITO SET Szkod = @szkod WHERE SzallitoID = @szallitoID
END