CREATE TRIGGER [dbo].[tr_szotar_modify] ON [dbo].[SZOTAR] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @szotarID smallint, @tipusID smallint, @neve varchar(50), @egyebInt int, @egyebBit bit,

		@dSzotarID smallint, @dTipusID smallint, @dNeve varchar(50), @dEgyebInt int, @dEgyebBit bit,

		@gcmMuvInt int

SELECT @szotarID=SzotarID, @tipusID=Tipus, @neve=Neve, @egyebInt=Egyebint, @egyebBit=EgyebBit FROM inserted

SELECT @dSzotarID=SzotarID, @dTipusID=Tipus, @dNeve=Neve, @dEgyebInt=Egyebint, @dEgyebBit=EgyebBit FROM deleted

--Csak az mgyarto
IF (ISNULL(@tipusID,0) = 17) OR (ISNULL(@dTipusID,0) = 17) 
BEGIN
	--Trls vagy (mdosts s nem webes)
	IF (@szotarID IS NULL AND @dSzotarID IS NOT NULL) OR (@szotarID IS NOT NULL AND @dSzotarID IS NOT NULL AND (@dEgyebBit = 1 AND @egyebBit = 0))
	BEGIN
		--Nem webes trlst nem kell kikldeni
		IF @dEgyebBit = 0
			RETURN

		SET @gcmMuvInt = 39 --Cikk gyrt trls
		SET @szotarID = @dSzotarID

		-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
		IF @webUserID <> ''
			UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @szotarID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 38) AND UserID = @webUserID

		IF @webUserID2 <> ''
			UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @szotarID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 38) AND UserID = @webUserID2
	END
	--j vagy mdosts
	ELSE
	BEGIN
		SET @gcmMuvInt = 38 --Cikk gyrt letlts

		--Mdosts
		IF @dSzotarID IS NOT NULL
		BEGIN

			--Nem webes mdostst nem kell kikldeni
			IF @egyebBit = 0
				RETURN

			--ha nem vltozott az tadott rtkek valamelyike
			IF @neve = @dNeve AND ISNULL(@egyebInt,0) = ISNULL(@dEgyebInt,0) AND @egyebBit = @dEgyebBit
				RETURN
		END
		--j
		ELSE
		BEGIN
			--Nem webes rgztst nem kell kikldeni
			IF @egyebBit = 0
				RETURN
		END
	END

	IF @webUserID <> ''
		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@szotarID,@webUserID)

	IF @webUserID2 <> ''
		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@szotarID,@webUserID2)
END
--Csak a cikkacst
ELSE IF (ISNULL(@tipusID,0) = 35) OR (ISNULL(@dTipusID,0) = 35) 
BEGIN
	--j vagy mdosts
	IF @szotarID IS NOT NULL
	BEGIN
		SET @gcmMuvInt = 80 --ltalnos cikkcsoport tpus letlts

		--Mdosts
		IF @dSzotarID IS NOT NULL
		BEGIN

			--ha nem vltozott az tadott rtkek valamelyike
			IF @neve = @dNeve
				RETURN

		END
	END
	ELSE
	BEGIN
		SET @gcmMuvInt = 81 --ltalnos cikkcsoport tpus trls
		SET @szotarID = @dSzotarID

		-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
		IF @webUserID <> ''
			UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @szotarID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 80) AND UserID = @webUserID

		IF @webUserID2 <> ''
			UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @szotarID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 80) AND UserID = @webUserID2
	END

	IF @webUserID <> ''
		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@szotarID,@webUserID)

	IF @webUserID2 <> ''
		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@szotarID,@webUserID2)
END