CREATE TRIGGER [dbo].[tr_utcak_modify] ON [dbo].[UTCAK] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @utcaID smallint, @csakNev varchar(40), @koztertpID smallint,

		@dUtcaID smallint, @dCsakNev varchar(40), @dKoztertpID smallint,

		@gcmMuvInt int

SELECT @utcaID=UtcaID, @csakNev=UtcaNev, @koztertpID=KoztertpID FROM inserted

SELECT @dUtcaID=UtcaID, @dCsakNev=UtcaNev, @dKoztertpID=KoztertpID  FROM deleted

--j vagy mdosts
IF @utcaID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 72 --Utca letlts

	--Mdosts
	IF @dUtcaID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @csakNev = @dCsakNev AND ISNULL(@koztertpID,0) = ISNULL(@dKoztertpID,0)
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 73 --Utca trls
	SET @utcaID = @dUtcaID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @utcaID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 72) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @utcaID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 72) AND UserID = @webUserID2
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@utcaID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@utcaID,@webUserID2)