CREATE procedure [dbo].[sp_android_szla]
 @vevoID int,@fizmodID int,@deviza tinyint,@creuser smallint,@szamlazott char(1)=null,@szamlazottID int=null,@sorok varchar(max),@kpVevoNev varchar(8000)=null
as
begin
declare @szkelt date,@fizhat date,@fizeto int,@fiznap tinyint,@fiznapV tinyint,@nev varchar(50),@fizmodIDV tinyint,@tombID tinyint,@netto money,@brutto money,@afa money,@tetszam smallint
declare @tombjel char(3),@vnaplokod char(1),@konyvev tinyint,@naploid int,@szszID int, @eszszid int,@aszszid int,@jogcimid int,@bizszov varchar(50),@tetelfejid int,@szamlaid int
declare @nettoS money,@bruttoS money,@szszam varchar(12),@VerzioSzam varchar(15)
-- sorokhoz
declare @pos bigint,@sortip char(1),@szolgID int,@cikkID int,@mennyi numeric (11,3),@egysegar money,@afaid tinyint,@afakulcs numeric (4,1),@egyeb varchar(200)
declare @eszsz varchar(8),@csereID int,@fszszid int,@fszszidS int,@devizaar money,@raktarID tinyint,@rendvsorID int,@arajsorid int,@bizsorid int,@uzemekid tinyint,@munkid int,@ktghelyid int,@kontid int,@konttet int,@fuvarjesID int

begin try
 begin tran
  select @konyvev=evekID from evek where year(getdate())=ev
  if @konyvev is null
   begin
    rollback tran
    select -6 as hiba,'Nincs v' as hibaszov
    return
   end

  set @tombjel=rtrim(dbo.fc_usetup(1,@creuser))
  select @tombID=tombID,@vnaplokod=vnaplokod,@jogcimid=jogcimid,@bizszov=jogcim.szoveg from SZLATOMB left join JOGCIM on JOGCIM.JogcimKod=SZLATOMB.JogcimKod and KonyvEv=@konyvev
    where tombjel=@tombjel and tombtilt='N' and tombjel<>'*' AND SZLATOMB.Egyszeru = 1
  if @@rowcount=0 
   begin
     rollback tran
     select -1 as hiba,'nincs szmlatmb' as hibaszov
     return
   end

  select @fizeto=fizeto,@fiznapV=fiznap,@nev=vevonev,@fizmodidV=fizmodid from vevo where vevoid=@vevoid
  if @@rowcount=0 
    begin
	 rollback tran
     select -2 as hiba,'nincs vev' as hibaszov
     return
   end
  if @fizeto is null OR @fizeto = 0
    set @fizeto=@vevoid
  set @szkelt=getdate()
  set @fizhat=getdate()
  if @fizmodid<>1
	begin
	   set @nev=null
	   select @fiznap=isnull(fizhatar,0),@nev=fizneve from fizmodok where fizmodID=@fizmodID
	   if @nev is null
		begin
			rollback tran
			select -3 as hiba,'nincs fizmod' as hibaszov
			return
		end
	   if @fizmodid=@fizmodIDv
	       begin
		 if isnull(@fiznapv,0)>0
		    set @fizhat=DATEADD(D,@fiznapv,@fizhat)
		 else
		    set @fizhat=DATEADD(D,@fiznap,@fizhat)			   			 
	       end
	   else
	     set @fizhat=DATEADD(D,@fiznap,@fizhat)			           
	end
  select @naploid=naploid,@fszszid=fszsz from naplofej where naplotip='V' and bkod=@vnaplokod and konyvEv=@konyvEv
  if @naploid is null
    begin
	 rollback tran
     select -5 as hiba,'nincs napl' as hibaszov
     return
    end

  create table #szsor (szsorid int,szolgid int,egysegar numeric(17,6),mennyiseg numeric (11,3),afaid int,tipus char(1),afakulcs tinyint,
    cikkid int,devizaar money,raktarid tinyint,rendvsorid int,arajsorid int,bizsorid int,kovetelid int,munkid int,ktghelyid int,egyeb varchar(500),fuvarjesID int)
  create table #kont (kontid int,szszID int,eszszID int,aszszID int,osszeg money,afaosszeg money,afaID int,bizszov varchar(50),jogcimid int,devizaban money,uzemekid int )
  create table #ktgfel (kontid int,munkID int,osszeg money,ktghelyid int )

-- Sorok vlogatsa 
 set @tetszam=0
 set @konttet=0
 select @nettoS=0,@bruttoS=0
 WHILE LEN(@sorok) > 0
   BEGIN
    set @sortip=left(@sorok,1)
	if @sortip<>'C' and @sortip<>'S'
    begin
	 rollback tran
     select -2 as hiba,'Sortipus nem C s nem S' as hibaszov
     return
   end

    if @sortip='C'
	     begin
		  select @cikkID=convert(int,substring(@sorok,2,7)),@szolgID=null
		  select @afaid=cikk.AfaID,@eszszid=sztukorid,@eszsz=CIKKCSOP.arbszam,@aszszid=asztukor.asztukorid from cikk 
		     left join cikkcsop on cikk.cikkcsopid=cikkcsop.cikkcsopid
			   left join sztukor on sztukor.szsz=cikkcsop.arbszam and sztukor.konyvev=@konyvev 
			 left join afak on cikk.afaid=afak.afaid left join  asztukor on asztukor.aszsz=afak.fokszam and asztukor.konyvev=@konyvev 
             where cikkID=@cikkID
		 end
	else
	     begin
	       select @szolgID=convert(int,substring(@sorok,2,7)),@cikkID=null
               select @fszszidS=esztukor.esztukorID,@eszsz=szolgal.bszsz,@afaid=afaid,@eszszid=sztukorid,@aszszid=asztukor.asztukorid,@ktghelyid=ktghely.ktghelyid,@munkid=munkszam.munkid,@uzemekid=uzemek.uzemekid from szolgal
		      left join sztukor on sztukor.szsz=szolgal.bszsz and sztukor.konyvev=@konyvev 
		      left join asztukor on asztukor.aszsz=szolgal.aszsz and asztukor.konyvev=@konyvev 
                      left join esztukor on esztukor.eszsz=szolgal.vszsz and esztukor.konyvev=@konyvev 		     			
                      left join ktghely on ktghely.ktghkod=szolgal.ktghkod and ktghely.konyvev=@konyvev 
		      left join munkszam on munkszam.munkkod=szolgal.munkkod and munkszam.konyvev=@konyvev 
		      left join uzemek on uzemek.uzemekid=szolgal.uzemekid
		      where szolgID=@szolgID
         end
		 if @afaid is null
		   begin
		     rollback tran
		     select -4 as hiba,'Sor:'+str(@tetszam+1) as hibaszov
		     return
		   end
    select @afakulcs=isnull(szaz,0) from afak where afaID=@afaid
    select @mennyi=convert(numeric (10,3),rtrim(LTRIM(substring(@sorok,9,10))))
    select @egysegar=convert(money,rtrim(LTRIM(substring(@sorok,19,10))))

    if charindex('|',@sorok)>29
		select @raktarID=convert(tinyint,rtrim(LTRIM(substring(@sorok,29,3))))
    else
		set @raktarID=0

    if @raktarid=0
		set @raktarid=null	
    
    if charindex('|',@sorok)>32 and @szamlazott='F' and @szamlazottID is not null
	begin
		select @fuvarjesID=convert(int,rtrim(LTRIM(substring(@sorok,32,10))))

		if @fuvarjesID=0
			set @fuvarjesID=null	
	end
    else
		set @fuvarjesID=null

	if charindex('|',@sorok)>42
	begin
		select @egyeb=rtrim(LTRIM(substring(@sorok,42,200)))
		
		if charindex('|',@egyeb)>0
			set @egyeb=LEFT(@egyeb,charindex('|',@egyeb)-1)
	end
    else
		set @egyeb=null	
    
	if @deviza=1
		select @devizaar=null
    else
       begin
		   --rfolyam!!!
		   set @devizaar=@egysegar
	end

    set @tetszam=@tetszam+1
    set @netto=round(@mennyi*@egysegar,0)
    set @afa=ROUND(@mennyi*@egysegar*@afakulcs/100,0)
    select @nettoS=@nettoS+@netto,@bruttoS=@bruttoS+@netto+@afa
    insert into #szsor (szsorid,szolgID,egysegar,mennyiseg,afaID,tipus,afakulcs,cikkID,devizaar,raktarID,rendvsorid,egyeb,fuvarjesID)
	values (@tetszam,@szolgID,@egysegar,@mennyi,@afaID,@sortip,@afakulcs,@cikkID,@devizaar,@raktarID,@rendvsorid,@egyeb,@fuvarjesID)
    if not @fszszIDS  is null
       set @fszszID=@fszszidS
    set @szszID=@fszszID
    if left(@eszsz,1)='8' and @netto<0
	 begin
	   set  @csereid=@szszID
	   set @szszid=@eszszid
	   set @eszszid=@csereID
	   set @netto=ABS(@netto)
	   set @afa=ABS(@afa)
	 end
   
	select @kontid=null
	select  @kontid=kontid from #kont 
	 where 	eszszID=@eszszID and szszID=@szszid and isnull(afaID,0)=isnull(@afaid,0) and isnull(aszszID,0)=isnull(@aszszid,0) and isnull(uzemekid,0)=isnull(@uzemekid,0)
  
    if isnull(@kontid,0)=0
      begin
        set @konttet=@konttet+1
	    insert into #kont (kontid,szszID, eszszID, aszszID, osszeg, afaosszeg, afaID, bizszov, jogcimid , devizaban,uzemekid)
	     values (@konttet,@szszID,@eszszid,@aszszid,@netto,@afa,@afaid,@bizszov,@jogcimID,@devizaar,@uzemekid)
      end
    else
      update #kont set osszeg=osszeg+@netto,afaosszeg=afaosszeg+@afa where kontid=@kontid


    if @munkid is not null or @ktghelyid is not null
	  begin
	     select @kontid=kontID from #ktgfel where @munkid=munkID and ktghelyid=@ktghelyid and kontid=@konttet
             if @kontid is null
		insert into #ktgfel values (@konttet,@munkid,@netto,@ktghelyid) 
             else
		update #ktgfel set osszeg=osszeg+@netto where kontid=@konttet
	  end
    set @pos=charindex('|',@sorok)
    if @pos>0   	
	  SELECT @sorok = SUBSTRING(@sorok, @pos+1, LEN(@sorok)-@pos)
    else
	  select @sorok=''

   end

--- Fej szerkesztse
  create table #szfej (vevoid int,fizeto int,szkelt date,fizhat date,tkelt date,kdatum date,fizmodid tinyint,szlahiv char(12),netto money,brutto money,creuser smallint,tetszam int,tombID int,
    tetelfejID int,naploID smallint,konttet tinyint,neve varchar(50),eloSzov text,utoszov text,KpVevonev text,Pnaplo char(1),Pnaplokod char(1),devizaid tinyint,devizaert money,arfolyam smallmoney,bankom tinyint,bankid smallint,kedvezmeny numeric(5,2),
     KeszPrgID tinyint,VerzioSzam varchar(15),KulonAFA char(1))

  select @verzioSzam=PrgVersion from programs where prgID=13
  insert into #szfej  (vevoid,fizeto,szkelt,fizhat,tkelt,kdatum,fizmodID,szlahiv,netto,brutto,creuser,tetszam,devizaID,arfolyam,tombID,naploid,tetelfejid,konttet,KeszPrgID,VerzioSzam,KulonAFA,KpVevonev)
   values (@vevoid,@fizeto,@szkelt,@fizhat,@szkelt,@szkelt,@fizmodID,'',@nettoS,@bruttoS,@creuser,@tetszam,@deviza,1,@tombID,@naploID,-1,@konttet,13,@VerzioSzam,'N',@kpVevoNev)
  create table #temp_szla (rgznaplo int,nev varchar(12),hiba int, hibaszov varchar(500),szszam varchar(12),szamlaid int,tetelfejid int)
  insert into #temp_szla exec sp_szla_insert

  select @tetelfejid=tetelfejid,@szamlaid=szamlaid from #temp_szla
  drop table #temp_szla
  Print @szamlaid
  if @tetelfejid>0  and @szamlaid>0
    begin
      create table #h2 (hiba int,hibaszov varchar(100))
      insert into #h2 exec sp_konyvel @tetelfejid 
      drop table #h2
      if @szamlazott='O' and @szamlazottID is not null
	   update OCSEREER set SzamlaID=@szamlaid,szamlaszam=@szszam where OcsereerID=@szamlazottID
      if @szamlazott='E' and @szamlazottID is not null
	   update fogyhell set SzamlaID=@szamlaid where FogyhellID=@szamlazottID
      if @szamlazott='F' and @szamlazottID is not null
	   update FUVARJEF set Statusz='S' where FuvarjefID=@szamlazottID	
      commit
      select 0 as hiba,'OK' as hibaszov,@szamlaid as szamlaid
     end
   else
     begin
   	rollback tran
	select -1 as hiba,'Nem jtt ltre a szmla' as hibaszov
     end 
 end try
  
 begin catch
   rollback tran
   select Error_number() as hiba,Error_message() as hibaszov
   return 
 end catch

end