CREATE PROCEDURE [dbo].[sp_digitalis_cimke_frissit]
AS 
BEGIN
	SET NOCOUNT ON

	DECLARE @toolsPath varchar(200), @command varchar(8000), @object int, @returnValue int, @proxyAcc varchar(50), @receiveVal varchar(8000)

	IF DB_NAME() LIKE '%teszt%'
		RETURN

	SELECT @proxyAcc = LTRIM(RTRIM(ProxyAcc)), @toolsPath = LTRIM(RTRIM(ToolsPath)) FROM CEG ORDER BY CegID

	IF @proxyAcc = ''
		SET @proxyAcc = NULL

	IF @toolsPath IS NULL
		RETURN

	IF RIGHT(@toolsPath,1) <> '\'
		SET @toolsPath = @toolsPath + '\'

	SELECT @command = @toolsPath+'DigitalisCimke\kri_dc.exe -operation:"fullSync" -server:"'+@@SERVERNAME+'" -database:"'+DB_NAME()+'"'

	IF @proxyAcc IS NOT NULL
	BEGIN
		EXECUTE AS USER = @proxyAcc
	END

	EXEC sp_oacreate 'WScript.Shell', @object OUT
	EXEC sp_oamethod @object, 'run', @returnValue OUT, @command
	EXEC sp_oadestroy @object

	IF @proxyAcc IS NOT NULL
	BEGIN
		REVERT
	END

END