CREATE PROCEDURE [dbo].[sp_hull_szerz] @lista char(1)='0'
AS
BEGIN
	SET NOCOUNT ON;
	
	DECLARE @szerzAll TABLE(
		VevoID int, VevoKod varchar(12), Elo varchar(5), VevoNev varchar(40), vevonevf varchar (50), PostaIrsz varchar(10), PostaVaros varchar(40),
		PostaCim varchar(50), Irsz varchar(10), Varos varchar(40), Cim varchar(50),	Adoszam varchar(13), 
		AdoAzon varchar(10), Vanyja varchar(35), SzulIdo date, SzulHely varchar(40), SzgIrsz varchar(10), SzgVaros varchar(40), 
		SzgUtca varchar(40), SzgCim varchar(40), SzgCimKieg varchar(50),szgcimveg varchar(15),UrUtca varchar (40),Urcim varchar(40),UrCimveg varchar(40),
		SzerzStatusz varchar(50), SzerzCspKod char(2), Szerzszam varchar(30), 
		KedenyID int, EdenyStatusz varchar(50), Tol date, Ig date, SzlaTip varchar(13), SzolgKod varchar(18), 
		SzolgNeve varchar(250), Darab smallint, Korrekcio numeric(3,2), Arlistas varchar(4), Ar money, 
		EdenySN varchar(20), Cimke varchar(20),Liter smallint, Fizneve varchar(25), Fiznap tinyint, KukaUritNv varchar(30),
		VCsopNev varchar(40), SzamlazhatTol varchar(4),	SzamlazhatIg varchar(4), FelfTol date, FelfIg date,
		BeszedoNev varchar(40),	UserNev varchar(30), CreTime smalldatetime, RezsiEves money, FoKedenyID int,SzgUtcaID int,szghelyid int,alternativ varchar(40)
		)
	
	INSERT INTO @szerzAll
	SELECT VEVO.VevoID, VEVO.VevoKod, VEVO.Elo, VEVO.VevoNev, isnull(vevonevf,'') as vevonevf,
		   (CASE WHEN VEVO.VevoLevID IS NULL THEN VAROSOK.VarosIrsz ELSE left(isnull(vevcim.kapcsertek,''),4) END) as PostaIrsz, 
		   (CASE WHEN VEVO.VevoLevID IS NULL THEN VAROSOK.VarosNev ELSE substring(isnull(vevcim.kapcsertek,''),6,25) END) as PostaVaros, 
		   (CASE WHEN VEVO.VevoLevID IS NULL THEN VEVO.Cim ELSE isnull(vevcim.kapcshozza,'') END) as Postacim,
	        VAROSOK.VarosIrsz, VAROSOK.VarosNev, VEVO.Cim, VEVO.Adoszam, 
	       VEVO.AdoAzon, VEVO.Vanyja, VEVO.VSzulido, SZULVAROS.VarosNev, SZGVAROS.VarosIrsz, SZGVAROS.VarosNev,
	       UTCAK.UtcaNev, SZGHELY.SzgCim, SZGHELY.SzgcimKieg,szghely.SzgCimveg,utcak2.utcanev2,utcak2.utcanev2,szghely.UrCimveg, SZOTAR.Neve, SZERZCSP.SzerzCspKD, VEVOSZRZ.Szerzszam,
	       KEDENY.KEdenyID, EDENYSTATUSZ.Neve, KEDENY.Tol, KEDENY.Ig, (CASE WHEN KEDENY.Szlamod = '' THEN 'rtsi djas' ELSE 'Havi djas' END), SZOLGAL.SzolgKod, 
	       SZOLGAL.SzolgNev + ISNULL(SZOLGAL.SzolgLeir, ''), KEDENY.Darab, KEDENY.Korrekcio, (CASE WHEN KEDENY.Arlistas = 1 THEN 'Igen' ELSE 'Nem' END), 
	       (CASE WHEN KEDENY.Arlistas = 1
		         THEN 
			         CASE WHEN eDijzonaID IS NOT NULL
			         THEN 
				         ARAKKUKA.EgysegAr
			         ELSE
				         (SELECT ARAKKUKA.EgysegAr
				         FROM DIJZONSV
					          INNER JOIN DIJZONA ON DIJZONSV.DijzonaID = DIJZONA.dijzonaID 
					          INNER JOIN ARAKKUKA ON DIJZONA.dijzonaID = ARAKKUKA.dijzonaID
				         WHERE SZGHELY.SzgVarosID = DIJZONSV.VarosID AND KEDENY.SzolgID = ARAKKUKA.SzolgID)
			         END
		         ELSE KEDENY.EEgysegAr 
	       END), 
	       KEDENY.EdenySN, KEDENY.Cimke,isnull(kedenyek.Urtartalom,0) as urtartalom, FIZMODOK.Fizneve, (CASE WHEN VEVO.Fiznap IS NULL THEN FIZMODOK.Fizhatar ELSE VEVO.Fiznap END), KUKAURIT.KukaUritNv, 
	       VEVOCSOP.VCsopNev,
	       RIGHT('0' + CAST(KEDENY.SzamTolHo AS varchar), 2)+ RIGHT('0' + CAST(KEDENY.SzamTolNap AS varchar), 2), 
	       RIGHT('0' + CAST(KEDENY.SzamIgHo AS varchar), 2) + RIGHT('0' + CAST(KEDENY.SzamIgNap AS varchar), 2), KEDENY.felftol, KEDENY.felfig, 
	       BESZEDOK.BeszedoNev,USERS.UserNev, KEDENY.CreTime, 
	       ISNULL((SELECT TOP 1 szamlav.evesmegtak FROM szamlav WHERE szamlav.VevoID = VEVO.VevoID AND szamlav.szghelyid = SZGHELY.SzghelyID
		    ORDER BY szamlav.SzamlaID DESC), 0) AS 'RezsiEves', kedeny.FoKedenyID,szghely.SzgUtcaID,SZGHELY.SzghelyID,UTCAK.Alternativ
		  
	FROM KEDENY
		INNER JOIN SZGHELY ON SZGHELY.SzghelyID = KEDENY.SzghelyID
		INNER JOIN VEVOSZRZ ON VEVOSZRZ.SzerzID = KEDENY.SzerzID
		INNER JOIN VEVO ON VEVOSZRZ.VevoID = VEVO.VevoID
		INNER JOIN SZERZCSP ON VEVOSZRZ.SzerzCspID = SZERZCSP.SzerzCspID
		INNER JOIN VAROSOK ON VEVO.VarosID = VAROSOK.VarosID
		INNER JOIN VAROSOK AS SZGVAROS ON SZGHELY.SzgVarosID = SZGVAROS.VarosID
		LEFT JOIN VAROSOK AS SZULVAROS ON VEVO.Vszulhely = SZULVAROS.VarosID
		INNER JOIN SZOTAR AS EDENYSTATUSZ ON KEDENY.Statusz = EDENYSTATUSZ.SzotarID
		INNER JOIN FIZMODOK ON VEVO.FizmodID = FIZMODOK.FizmodId
		INNER JOIN SZOLGAL ON KEDENY.SzolgID = SZOLGAL.SzolgID
		INNER JOIN USERS ON KEDENY.CreUser = USERS.UserID
		LEFT JOIN SZOTAR ON VEVOSZRZ.Statusz = SZOTAR.SzotarID
		LEFT JOIN ARAKKUKA AS ARAKKUKA ON SZOLGAL.SzolgID = ARAKKUKA.SzolgID AND KEDENY.eDijzonaID = ARAKKUKA.dijzonaID
		LEFT JOIN KUKAURIT ON KEDENY.kukauritID = KUKAURIT.KukaUritID
		LEFT JOIN VEVOCSOP ON VEVOCSOP.VCsopID = VEVO.VCsopID
		LEFT JOIN UTCAK ON UTCAK.UtcaID = SZGHELY.SzgUtcaID
		LEFT JOIN UTCAK2 ON UTCAK2.UtcakID2 = SZGHELY.UrUtcaID
		LEFT JOIN BESZEDOK ON BESZEDOK.BeszedoID = VEVO.BeszedoID
		left join kedenyek on kedeny.Kedenyekid=kedenyek.KedenyekID
		left join vevcim on vevcim.vevokpcsid=vevo.VevoLevID
		
	ORDER BY VEVO.VevoID, SZGHELY.SzgVarosID, SZGHELY.SzgUtcaID, VEVOSZRZ.Szerzszam

  /*  DECLARE @vevoKpcs TABLE(VevoID int, KapcsHozza varchar(40), VarosIrsz varchar(10), VarosNev varchar(40))
	
	INSERT INTO @vevoKpcs
	SELECT VEVOKPCS.VevoID, VEVOKPCS.KapcsHozza, VAROSOK.VarosIrsz, ISNULL(VAROSOK.VarosNev, VEVOKPCS.KapcsErtek) AS 'VarosNev'
	FROM VEVOKPCS
		 LEFT JOIN VAROSOK ON VEVOKPCS.varosID = VAROSOK.VarosID
	WHERE KapcsTip = 5 AND VevokpcsID = (SELECT MAX(VEVOKPCS_1.VevokpcsID) FROM VEVOKPCS AS VEVOKPCS_1 WHERE VEVOKPCS_1.VevoID = VEVOKPCS.VevoID AND KapcsTip = 5)
	ORDER BY VevoID
	
	-- Futsid: 0:35
	
	UPDATE @szerzAll
	SET PostaIrsz = KAPCS.VarosIrsz, PostaVaros = KAPCS.VarosNev, PostaCim = KAPCS.KapcsHozza 
	FROM @szerzAll AS SZERZ
	     INNER JOIN @vevoKpcs AS KAPCS ON SZERZ.VevoID = KAPCS.VevoID

	-- Futsid: 1:04
	*/


	/* 
	DECLARE @vevoID int, @kapcsHozza varchar(40), @varosIrsz varchar(10), @varosNev varchar(40)
	DECLARE KapcsCursor CURSOR FOR

	SELECT VEVOKPCS.VevoID, VEVOKPCS.KapcsHozza, VAROSOK.VarosIrsz, ISNULL(VAROSOK.VarosNev, VEVOKPCS.KapcsErtek) AS 'VarosNev'
	FROM VEVOKPCS
		 LEFT JOIN VAROSOK ON VEVOKPCS.varosID = VAROSOK.VarosID
	WHERE KapcsTip = 5 AND VevokpcsID = (SELECT MAX(VEVOKPCS_1.VevokpcsID) FROM VEVOKPCS AS VEVOKPCS_1 WHERE VEVOKPCS_1.VevoID = VEVOKPCS.VevoID AND KapcsTip = 5)
	ORDER BY VevoID

	OPEN KapcsCursor;

	FETCH NEXT FROM KapcsCursor INTO @vevoID, @kapcsHozza, @varosIrsz, @varosNev
	WHILE @@FETCH_STATUS = 0
	   BEGIN
		  UPDATE @szerzAll SET PostaIrsz = @varosIrsz, PostaVaros = @varosNev, PostaCim = @kapcsHozza WHERE VevoID = @vevoID
		  
		  FETCH NEXT FROM KapcsCursor INTO @vevoID, @kapcsHozza, @varosIrsz, @varosNev
	   END;
	CLOSE KapcsCursor;
	DEALLOCATE KapcsCursor;
	
	Futsid: 1:12
	*/
	
	if @lista='1'
		SELECT VevoID AS 'Vev ID', VevoKod AS 'Vevkd', Elo AS 'Elnv', VevoNev AS 'VevNv', vevonevf as 'Vevnv folyt',PostaIrsz AS 'Posta irsz', PostaVaros AS 'Posta vros', 
	       PostaCim AS 'Posta cm', Irsz AS 'Irsz', Varos AS 'Vros', Cim AS 'Cm',
		   SzgIrsz AS 'Szghely irsz', SzgVaros AS 'Szghely vros', 
	       SzgUtca AS 'Szghely utca', SzgCim AS 'Szghely cm', SzgcimKieg AS 'Szghely cmkieg.',
		   
		   case
 when
    LEFT(szgcimveg,3) IN('999','000','   ')  OR SzgCimveg IS null
then ''
else
  str(convert(int,LEFT(SzgCimveg,3)))
end as 'Hsz1', 

case
 when
    left(szgcimveg,3) IN('999','000','   ')  OR SzgCimveg IS null or substring(SzgCimveg,13,3)='   '
then ''
else
  str(convert(int,substring(SzgCimveg,13,3)))
end as 'Hsz2', 
case
 when
    left(szgcimveg,3) IN('999','000','   ')  OR SzgCimveg IS null
then ''
else
  upper(substring(SzgCimveg,4,2))
end as 'plet', 

case
 when
    left(szgcimveg,3) IN('999','000','   ')  OR SzgCimveg IS null
then ''
else
  upper(substring(SzgCimveg,6,2))
end as 'Lpcshz', 

case
 when
    left(szgcimveg,3) IN('999','000','   ')  OR SzgCimveg IS null
then ''
else
  upper(substring(SzgCimveg,8,2))
end as 'Emelet', 

case
 when
    left(szgcimveg,3) IN('999','000','   ')  OR SzgCimveg IS null
then ''
else
  upper(substring(SzgCimveg,10,3))
end as 'Ajt', 		

case
 when
   LEFT(szgcimveg,3)='999'
 then SUBSTRING(szgcimveg,4,12)
 else
  ''
 end as 'Hrsz', szgcimveg as 'Cmkd',
   		   
		   SzerzCspKod AS 'RS-kd', Szerzszam AS 'Szerzdsszm', KedenyID AS 'Edny sorszm',
	       EdenyStatusz AS 'Edny sttusz', Tol AS 'Edny szerzdskezdet', Ig AS 'Edny szerzdsvg', SzlaTip AS 'Szmlzs tpusa', SzolgKod AS 'Szolgltats kd', 
	       SzolgNeve AS 'Szolgltats', Darab, Korrekcio AS 'Korrekci', FoKedenyID as 'Megosztva',
		    
	       EdenySN AS 'Edny sorozatszm', Cimke AS 'Cmke', Liter, KukaUritNv AS 'rts', 
	       VCsopNev AS 'Vevcsoport', SzamlazhatTol AS 'Szmlzhatsg -tl', SzamlazhatIg 'Szmlzhatsg -ig', FelfTol AS 'Felfgesztve -tl', FelfIg AS 'Felfggesztve -ig', 
	       BeszedoNev AS 'Kzbest',SzgUtcaID as 'Utca ID',SzghelyID as 'SzghelyID',alternativ as 'Cserenv'
	FROM @szerzAll

	else
	SELECT VevoID AS 'Vev ID', VevoKod AS 'Vevkd', Elo AS 'Elnv', VevoNev AS 'VevNv', vevonevf as 'Vevnv folyt',PostaIrsz AS 'Posta irsz', PostaVaros AS 'Posta vros', 
	       PostaCim AS 'Posta cm', Irsz AS 'Irsz', Varos AS 'Vros', Cim AS 'Cm', Adoszam AS 'Adszm', 
	       AdoAzon AS ' Adazonost', Vanyja AS 'Anyja neve', SzulIdo AS 'Szletsi id', SzulHely AS 'Szletsi hely', SzgIrsz AS 'Szghely irsz', SzgVaros AS 'Szghely vros', 
	       SzgUtca AS 'Szghely utca', SzgCim AS 'Szghely cm', SzgcimKieg AS 'Szghely cmkieg.',szgcimveg as 'Szghely hsz', 
		   case  when urutca is null then szgutca else UrUtca end  as 'rts utca',
		   
		   case when urutca is null then szgcim else
		   rtrim(isnull(urutca,''))+' '+
		    case
 when
    LEFT(urcimveg,3) IN('999','000','   ')  OR UrCimveg IS null
then ''
else
  str(convert(int,LEFT(UrCimveg,3)),3)
end +

case
 when
    left(urcimveg,3) IN('999','000','   ')  OR UrCimveg IS null or substring(UrCimveg,12,3)='   '
then ''
else
  '-'+str(convert(int,substring(UrCimveg,12,3)),3)
end end
 as 'rtsi cm', 
		   SzerzStatusz AS 'Szerzds sttusz', SzerzCspKod AS 'RS-kd', Szerzszam AS 'Szerzdsszm',
	       KedenyID AS 'Edny sorszm', EdenyStatusz AS 'Edny sttusz', Tol AS 'Edny szerzdskezdet', Ig AS 'Edny szerzdsvg', SzlaTip AS 'Szmlzs tpusa', SzolgKod AS 'Szolgltats kd', 
	       SzolgNeve AS 'Szolgltats', Darab, Korrekcio AS 'Korrekci', FoKedenyID as 'Megosztva', Arlistas AS 'rlists', Ar AS 'r', 
	       EdenySN AS 'Edny sorozatszm', Cimke AS 'Cmke', Liter ,Fizneve AS 'Fizetsmd', Fiznap AS 'Fizets nap', KukaUritNv AS 'rts', 
	       VCsopNev AS 'Vevcsoport', SzamlazhatTol AS 'Szmlzhatsg -tl', SzamlazhatIg 'Szmlzhatsg -ig', FelfTol AS 'Felfgesztve -tl', FelfIg AS 'Felfggesztve -ig', 
	       BeszedoNev AS 'Kzbest', UserNev AS 'Rgzt', CreTime AS 'Rgzts', RezsiEves AS 'Gngylt rezsi'
	FROM @szerzAll

END