CREATE PROCEDURE [dbo].[sp_keszlet_evnyit] @creUser int, @konyvEv int 

AS
BEGIN
	DECLARE @c int 
	SELECT @c = COUNT(*) FROM MOZGNEM WHERE KonyvEv = @KonyvEv + 1

	IF ISNULL(@c, 0) > 0
	BEGIN
		SELECT -1 AS hiba, 'M  r  m e g n y i t v a !' AS hibaszov
		RETURN  
	END

	BEGIN TRY
		INSERT INTO MOZGNEM (SzallLev, TelepID, DevizaID, SpecKod, MnemNeve, MnemRov, Irany, Partner, SzSzam, Bizjel, Bizonylatc, Kulso, KonyvEv, Raktarak, CreUser, Mszsz, EszkozKell, Peldany, Bizhosz)
		SELECT SzallLev, TelepID, DevizaID, SpecKod, MnemNeve, MnemRov, Irany, Partner, SzSzam, Bizjel, Bizonylatc, Kulso, @konyvEv + 1, Raktarak, @creUser, Mszsz, EszkozKell, Peldany, Bizhosz
		FROM MOZGNEM
		WHERE KonyvEv = @konyvEv

		SELECT 0 AS hiba, 'O.K.' AS hibaszov
	END TRY
	BEGIN CATCH
		SELECT Error_number() AS hiba, Error_message() AS hibaszov
		RETURN 
	END CATCH
END