CREATE PROCEDURE sp_konyvel_kot
@rgzid int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;
declare @konyvmod varchar(1),@afaid tinyint
declare @szszid int,@eszszID int,@aszszID int,@tartozik money,@kovetel money,@afaosszeg money
declare @kszam int,@osszegs money,@tkjel bit,@szt bit,@sze bit,@tetelsorID int,@bizkelt date,@kidoszakid int,@zart char(1),@konyvev int 

begin tran
  begin try
  select @konyvmod=rgznaplo.konyvmod,@konyvev=Konyvev from RGZNAPLO left join naplofej on naplofej.naploid=rgznaplo.naploid where RgzID=@rgzid 
  if ISNULL(@konyvmod,' ')=''
    begin
     commit   
     select -1 as hiba,'Mr knyvelt!' as hibaszov
     return
    end
    
  declare cur_koteg cursor for
    select szszid,eszszid,aszszID,afaid,bizkelt,tkjel,min(tetelsorid) as tetelsorID,sum(tartozik) as tartozik,sum(kovetel) as kovetel,sum(afaosszeg) as afaosszeg
      from tetelsor
    left join tetelfej on tetelfej.tetelfejID=tetelsor.tetelfejID
    where rgzid=@rgzID and konyvelve<>'I'
     group by szszID,esszID,aszszID,afaID,bizkelt,tkjel
     order by bizkelt
   open cur_koteg 
    fetch from cur_koteg into @szszID,@eszszID,@aszszID,@afaid,@bizkelt,@tkjel,@tetelsorID,@tartozik,@kovetel,@afaosszeg
    while @@Fetch_status=0
        begin
         
         select @zart=zart from kidoszak 
            where @bizkelt>=kidoszak.tol and kidoszak.ig>=@bizkelt and KonyvEv=@Konyvev and Ho<>0 and Ho<>13
            if @zart='I'
             begin
 		rollback tran
   		close cur_koteg
  		deallocate cur_koteg
                select -4 as hiba,'Z  r t   i d  s z a k ! ' as hibaszov
                return
             end 
         set @szszid=isnull(@szszid,0)
         set @eszszid=isnull(@eszszid,0)
         if  @szszid>0 and @eszszid>0
           begin
              select @kszam=@kszam+1
              set @osszegs=@osszegs+@tartozik
				if @tkjel='True'
					begin
				     set @szt='True'
					 set @sze='False'
                    end
                else
					begin
                      set @sze='True'
                      set @szt='False'     
                    end
                insert into kontir (tetelsorID,sztukorID,Osszeg,tkjel,eszszID,aszszID) 
                   values (@tetelsorID,@szszID,@tartozik,@szt,@eszszID,@aszszID)

                insert into kontir (tetelsorID,sztukorID,Osszeg,tkjel,eszszID) 
                   values (@tetelsorID,@eszszID,@kovetel,@sze,@szszID)
 
                if @afaosszeg<>0
                   insert into kontir (tetelsorID,sztukorID,Osszeg,tkjel,eszszID) 
                      values (@tetelsorID,@aszszID,@afaosszeg,@sze,@szszID)
         end
    
        fetch next from cur_koteg into @szszID,@eszszID,@aszszID,@afaid,@bizkelt,@tkjel,@tetelsorID,@tartozik,@kovetel,@afaosszeg

    end
     
   close cur_koteg
   deallocate cur_koteg 
   update RGZNAPLO set KonyvMod='' where RgzID=@rgzid
   update TETELFEJ set Konyvelve='I',KonyvTime=getdate()  where RgzID=@rgzid
  commit
   select 0 as hiba,'OK' as hibaszov
  return
  end try
 

begin catch
 rollback tran
   close cur_koteg
  deallocate cur_koteg
 
 select Error_number() as hiba,Error_message() as hibaszov
 return 
end catch

end
