CREATE PROCEDURE [dbo].[sp_szla_ker_insert]
AS
BEGIN

--#szfej
DECLARE
@szamlaID int, @vevoid int, @fizeto int, @szkelt date, @fizhat date,
@tkelt date, @fizmodid tinyint, @netto money, @brutto money, @creUser smallint,
@tetszam int, @tombID int, @tetelfejID int, @naploID int, @konttet tinyint,
@eloszov varchar(1000), @utoszov varchar(1000), @kpvevonev varchar(8000), @pnaplo char(1), @pnaplokod char(1),
@szlahiv char(12), @devizaid tinyint, @arfolyam smallmoney, @devizaert money, @kdatum date,
@uzlKotoID smallint, @riportosID smallint, @kedvezmeny numeric(5,2), @vevokpcsID int, @bankID smallint,
@fejlecID tinyint, @bankomID tinyint, @kerekites numeric(3,1), @szlaStatus char(1), @veg char(1),
@termekDij smallmoney, @telepID tinyint, @eloleg money, @verzioSzam varchar(12),
@kulonAFA char(1), @arkategID tinyint, @kiszallit bit, @logKtgSz numeric(4,2),

--#szsor
@szsorId int, @egysegar numeric (17,6), @mennyiseg numeric(11,3), @afaid int, @szolgID int,
@cikkID int, @tipus char(1), @afakulcs tinyint, @devizaar smallmoney, @raktarid tinyint,
@arajvsorID int, @rendvsorID int, @bizsorID int, @egyeb varchar(200), @maradek numeric(10,3),
@engedmeny numeric(5,2), @munkSzolID int, @eSzamlaID int, @pSztetelID int, @cikkSarzID int,

--trhely kezels
@polcSorok varchar(MAX), @tarhelyes bit, @keszletBizsorID int, @position bigint, @forrasRaktarPID int,
@celRaktarPID int, @pMennyi numeric(10,3), @hiba int, @hibaszov varchar(MAX), @maradekBizsorID int,
@keszletPID int,

--#kont
@szszID int, @eszszID int, @aszszID int, @osszeg money, @afaosszeg money,
@bizszov varchar(50), @jogcimID int, @devizaban money, @uzemekid int,

--trolt eljrs vltozi
--szmlaszm kpzs
@szszam varchar(12), @tombsorsz int, @tombjel char(3), @tombkepzes char(1), @elonull tinyint,
@jogcimkod char(6), @Rjogcimkod char(6), @tombel char(1), @tombelk char(1),

--NAPLOFEJ
@konyvev tinyint, @bbizszam char(12),

--RGZNAPLO
@rgznaploid int, @rgzneve char(11),

--SZAMLAK
@devizafiz money,

--TETELSOR
@irany char(1), @tkjel bit,

--SZTETEL
@sztetelID int, @beszAr money, @elfekvo bit,

--kszlet
@kellkeszlet bit, @bizfejID int, @mozgnemid int, @keszl_afaid tinyint, @atlagar money,

--szmlatmb v (szmlakeltbl)
@szkonyvEv tinyint,

--maradkos sorbonts
@afaIDC tinyint, @meeIDC tinyint, @fejIDC int, @megjegyzC varchar(200), @egysegarC money, @kedvezmenyC numeric(5,2), @RaktarIDC tinyint, @devizaArC smallmoney, @eladArC money, @afakulcsC tinyint,
--BIZSOR sorbonts
@ertekC money, @bizsorUjErtek money,

--proforma szmla
@proforma bit, @pszamlaID int,

--tranzakci kezels
@ujTranzakcio bit = 0

SELECT @vevoid=vevoid,@fizeto=fizeto,@szkelt=szkelt,@fizhat=fizhat,@tkelt=tkelt,
	   @fizmodid=fizmodid,@netto=netto,@brutto=brutto,@creuser=creuser,@tetszam=tetszam,
	   @tombid=tombid,@tetelfejID=tetelfejID,@naploID=naploID,@konttet=konttet,@Eloszov=Eloszov,
	   @Utoszov=utoszov,@kpvevonev=Kpvevonev,@pnaplo=pnaplo,@pnaplokod=pnaplokod,@szlahiv=szlahiv,
	   @devizaid=devizaid,@arfolyam=arfolyam,@devizaert=devizaert,@kdatum=kdatum,@uzlKotoID=uzlKotoID,
	   @riportosID=riportosID,@kedvezmeny=kedvezmeny,@vevokpcsID=vevokpcsID,@bankID=bankID,@fejlecID=fejlecID,
	   @bankomID=bankomID,@pszamlaID=pszamlaID,@kerekites=kerekites,@szlaStatus=szlaStatus,@veg=veg,
	   @termekDij=termekDij,@telepID=telepID,@eloleg=eloleg,@verzioSzam=verzioSzam,
	   @kulonAFA=kulonAFA, @arkategID=arkategID, @kiszallit=kiszallit, @logKtgSz=logKtgSz
FROM #szfej

IF @arfolyam=1
	SET @devizaert=NULL

BEGIN TRY
	IF @@TRANCOUNT = 0
	BEGIN
		SET @ujTranzakcio = 1
		BEGIN TRAN
	END

	--szmlaszm kpzs
	SELECT @szkonyvEv=EvekID FROM EVEK WHERE LEFT(Ev,4)=STR(YEAR(@szkelt),4)

	UPDATE SZLATMBS SET TombSorsz=TombSorsz+1,Last_kelt=@szkelt WHERE TombID=@tombID AND TombEv=@szkonyvEV

	SELECT @tombsorsz=isnull(TombSorsz,0),@szszam=TombEvKep FROM SZLATMBS WHERE tombID=@tombID and TombEv=@szkonyvEV

	SELECT @tombjel=isnull(TombJel,''),@tombkepzes=TombKepzes,@elonull=Elonull,@jogcimkod=JogcimKod,@Rjogcimkod=Rjogcimkod,@tombel=isnull(Tombel,''),@tombelk=isnull(Tombelk,''),@proforma=Proforma FROM SZLATOMB WHERE TombID=@tombID

	IF @tombkepzes='B'
		SET @szszam=RTRIM(@tombjel)+RTRIM(@tombel)+RTRIM(@szszam)+RTRIM(@tombelk)+RIGHT('00000'+LTRIM(STR(@tombsorsz)),@elonull)
	IF @tombkepzes='S'
		SET @szszam=RIGHT('00000'+LTRIM(STR(@tombsorsz)),@elonull)+RTRIM(@tombel)+RTRIM(@tombjel)+RTRIM(@tombelk)+RTRIM(@szszam)
	IF @tombkepzes='N'
		SET @szszam=RIGHT('00000'+LTRIM(STR(@tombsorsz)),@elonull)+RTRIM(@tombel)+RTRIM(@szszam)+RTRIM(@tombelk)+RTRIM(@tombjel)

	IF @devizaID<>1
		SET @devizafiz=0
	ELSE
		SET @devizafiz=null

	--proforma szmla
	IF @proforma = 1
	BEGIN
		INSERT INTO PSZAMLAK (VevoID,Fizeto,Szszam,Szkelt,Fizhat,
							  Tkelt,FizmodID,Netto,Brutto,CreUser,
							  EloSzov,UtoSzov,KpVevonev,TombID,DevizaID,
							  DevizaErt,RiportosID,Kedvezmeny,UzlKotoID,VevokpcsID,
							  Arfolyam,BankID,FejlecID,BankomID,Kerekites,
							  Kiszallit,Statusz,LogKtgSz)
					  VALUES (@vevoid,@fizeto,@szszam,@szkelt,@fizhat,
							  @tkelt,@fizmodid,@netto,@brutto,@creUser,
							  @Eloszov,@Utoszov,@KpVevonev,@tombid,@devizaid,
							  @devizaert,@riportosID,@kedvezmeny,@uzlKotoID,@vevokpcsID,
							  @arfolyam,@bankID,@fejlecID,@bankomID,@kerekites,
							  @kiszallit,'N',@logKtgSz)

		SET @szamlaID=SCOPE_IDENTITY()

		SET @szsorid=1
		WHILE @tetszam>=@szsorID
		BEGIN
			SELECT @egysegar=egysegar,@mennyiseg=mennyiseg,@afaid=afaid,@szolgID=szolgid,@cikkid=cikkid,
				   @tipus=tipus,@afakulcs=afakulcs,@devizaar=devizaar,@raktarid=raktarid,@arajvsorID=arajvsorID,
				   @rendvsorID=rendvsorID,@bizsorID=bizsorID,@egyeb=egyeb,@maradek=maradek,@engedmeny=engedmeny,
				   @munkSzolID=munkSzolID
			FROM #szsor
			WHERE szsorID=@szsorID

			INSERT INTO PSZTETEL (PSzamlaID,EgysegAr,Mennyiseg,AfaID,Afakulcs,
								  SzolgID,CikkID,Tipus,DevizaAr,Egyeb,
						 		  RaktarID,Engedmeny)
						  VALUES (@szamlaID,@egysegar,@mennyiseg,@afaid,@afakulcs,
								  @szolgID,@CikkID,@tipus,@devizaAr,@egyeb,
								  @raktarid,@engedmeny)

			SET @sztetelID=SCOPE_IDENTITY()

			SET @szsorid=@szsorid+1

			--rajnlatbl szmlzott
			IF (@arajvsorID IS NOT NULL)
			BEGIN
				--szmlattel bejegyzs
				UPDATE ARAJVSOR SET PSztetelID = @sztetelID WHERE ArajVSorid = @arajvsorID

				IF (@maradek IS NOT NULL)
				BEGIN
					--eredeti sor
					SELECT @afaIDC=Afaid, @meeIDC=RsorMeid, @fejIDC=ArajVFejID, @megjegyzC=Megjegyz, @egysegarC=Egysegar, @kedvezmenyC=Kedvezs, @RaktarIDC=RaktarID FROM ARAJVSOR WHERE ArajVSorid = @arajvsorID

					--maradk sor felvitel (eredeti sorbl 2 sor)
					INSERT INTO ARAJVSOR (Afaid, RsorMeid, ArajVFejID, Rtipus, CikkID,
										  SzolgID, Megjegyz, Mennyi, Egysegar, Kedvezs,
										  CreUser, RaktarID, TetelSorsz)
								  VALUES (@afaIDC, @meeIDC, @fejIDC, @tipus, @cikkID,
										  @szolgID, @megjegyzC, @maradek, @egysegarC, @kedvezmenyC,
										  @creUser, @RaktarIDC, (SELECT MAX(TetelSorsz) + 1 FROM ARAJVSOR WHERE ArajVFejID = @fejIDC))

					--eredeti mennyisg javtsa
					UPDATE ARAJVSOR SET Mennyi = @mennyiseg WHERE ArajVSorid = @arajvsorID
				END
			END
			--rendelsbl szmlzott
			ELSE IF (@rendvsorID IS NOT NULL)
			BEGIN
				--szmlattel bejegyzs
				UPDATE RENDVSOR SET PSztetelID = @sztetelID WHERE RendvsorID = @rendvsorID

				IF (@maradek IS NOT NULL)
				BEGIN
					--eredeti sor
					SELECT @afaIDC=AfaID, @meeIDC=rsormeid, @fejIDC=RendvfejID, @megjegyzC=Megjegyz, @egysegarC=Egysegar, @kedvezmenyC=Kedvezs, @RaktarIDC=Raktid FROM RENDVSOR WHERE RendvsorID = @rendvsorID

					--maradk sor felvitel (eredeti sorbl 2 sor)
					INSERT INTO RENDVSOR (AfaID, rsormeid, RendvfejID, Rtipus, CikkID,
										  SzolgID, Megjegyz, Mennyi, Egysegar, Kedvezs,
										  Raktid, CreUser, TetelSorsz)
								  VALUES (@afaIDC, @meeIDC, @fejIDC, @tipus, @cikkID,
										  @szolgID, @megjegyzC, @maradek, @egysegarC, @kedvezmenyC,
										  @RaktarIDC, @creUser, (SELECT MAX(TetelSorsz) + 1 FROM RENDVSOR WHERE RendvfejID = @fejIDC))

					--eredeti mennyisg javtsa
					UPDATE RENDVSOR SET Mennyi = @mennyiseg WHERE RendvsorID = @rendvsorID
				END
			END
			--szlltlevlbl szmlzott
			ELSE IF (@bizsorID IS NOT NULL)
			BEGIN
				--szmlattel bejegyzs
				UPDATE BIZSOR SET PSztetelID = @sztetelID WHERE BizsorID = @bizsorID

				IF (@maradek IS NOT NULL)
				BEGIN
					--eredeti sor
					SELECT @afaIDC=AfaID, @meeIDC=RsorMeID, @fejIDC=BizfejID, @megjegyzC=Megjegyz, @egysegarC=EgysegAr, @kedvezmenyC=KedvezS, @RaktarIDC=RaktarID, @devizaArC=DevizaAr, @eladArC=EladAr, @ertekC=Ertek FROM BIZSOR WHERE BizsorID = @bizsorID

					SET @bizsorUjErtek = @egysegarC * @mennyiseg;

					--maradk sor felvitel (eredeti sorbl 2 sor)
					INSERT INTO BIZSOR (AfaID, RsorMeID, BizfejID, Rtipus, CikkID,
										SzolgID, Megjegyz, Mennyi, EgysegAr, KedvezS,
										RaktarID, DevizaAr, EladAr, Ertek, CreUser)
								VALUES (@afaIDC, @meeIDC, @fejIDC, @tipus, @cikkID,
										@szolgID, @megjegyzC, @maradek, @egysegarC,	@kedvezmenyC,
										@RaktarIDC, @devizaArC, @eladArC, @ertekC - @bizsorUjErtek, @creUser)

					--eredeti mennyisg javtsa
					UPDATE BIZSOR SET Mennyi = @mennyiseg, Ertek = @bizsorUjErtek WHERE BizsorID = @bizsorID
				END
			END
			--munkalap szolgltatsbl szmlzott
			ELSE IF (@munkSzolID IS NOT NULL)
			BEGIN
				--szmlattel bejegyzs
				UPDATE MUNKSZOL SET PSztetelID = @sztetelID WHERE MunkSzolID = @munkSzolID

				IF (@maradek IS NOT NULL)
				BEGIN
					--eredeti sor
					SELECT  @fejIDC=MunkalapID, @egysegarC=EgysegAr, @afaIDC=AfaID, @megjegyzC=Megjegyzes FROM MUNKSZOL WHERE MunkSzolID = @munkSzolID

					--maradk sor felvitel (eredeti sorbl 2 sor)
					INSERT INTO MUNKSZOL (MunkalapID, SzolgID, Mennyi, Egysegar, AfaID,
										  CreUser, Megjegyzes)
								  VALUES (@fejIDC, @szolgID, @maradek, @egysegarC, @afaIDC, 
										  @creUser, @megjegyzC)

					--eredeti mennyisg javtsa
					UPDATE MUNKSZOL SET Mennyi = @mennyiseg WHERE MunkSzolID = @munkSzolID
				END
			END
		END

		IF @ujTranzakcio = 1
			COMMIT

		SELECT 0 AS rgznaplo,'' AS nev,0 AS hiba,'OK' AS hibaszov,@szszam AS szszam,@szamlaID AS szamlaID
		RETURN
	END

	--meglv rgztsi napl
	IF @tetelfejID=-1
	BEGIN
		SELECT @rgznaploid=RgzID,@rgzneve=Rgzneve FROM RGZNAPLO WHERE NaploID=@naploID AND Zart='N' ORDER BY RgzID DESC

		 IF ISNULL(@rgznaploid,0)=0
			SET @tetelfejID=0
	END

	--j rgztsi napl
	IF @tetelfejID=0
	BEGIN
		UPDATE RGZNAPLO SET Zart='I' WHERE NaploID=@naploID AND Zart='N'

		SELECT @rgzneve=NAPLOFEJ.NaploTip+NAPLOFEJ.Bkod+RIGHT(RTRIM(EVEK.Ev),2)+'-'+RIGHT('00'+LTRIM(STR(MONTH(@szkelt),2)),2)+'-'+RIGHT('000'+LTRIM(STR(NAPLOFEJ.RgzSorszam,3)),3)
        FROM NAPLOFEJ
			 LEFT JOIN EVEK ON NAPLOFEJ.KonyvEv=EVEK.EvekID
		WHERE NAPLOFEJ.NaploID=@naploID

		INSERT INTO RGZNAPLO (NaploID,CreUser,Zart,Rgzneve)
		              VALUES (@naploID,@creUser,'N',@rgzneve)

		SELECT @rgznaploid=SCOPE_IDENTITY()
	END

	UPDATE NAPLOFEJ SET Sorszam=Sorszam+1 WHERE NaploID=@naploID

	SELECT @konyvev=NAPLOFEJ.KonyvEv,@bbizszam=NAPLOFEJ.NaploTip+NAPLOFEJ.Bkod+RIGHT(RTRIM(EVEK.Ev),2)+'-'+RIGHT('00000'+LTRIM(STR(NAPLOFEJ.Sorszam,NAPLOFEJ.BizHosz)),NAPLOFEJ.BizHosz)
	FROM NAPLOFEJ
		 LEFT JOIN EVEK ON NAPLOFEJ.KonyvEv=EVEK.EvekID
	WHERE NAPLOFEJ.NaploID=@naploID

    IF @kdatum IS NULL OR @kdatum='1900.01.01'
		SET @kdatum=@tkelt

	IF @konttet > 0
	BEGIN
		INSERT INTO TETELFEJ (NaploID,Bizkelt,Ekelt,Bbizszam,Bizszam,
							  CreUser,Tetelszam,KonyvEv,Naplotip,RgzID,
							  Arfolyam)
					  VALUES (@naploID,@kdatum,@tkelt,@bbizszam,@szszam,
							  @creUser,0,@KonyvEv,'V',@rgznaploid,
							  @arfolyam)

		SELECT @tetelfejID=SCOPE_IDENTITY()
	END
	ELSE
	BEGIN
		SET @tetelfejID = -1
	END

	INSERT INTO SZAMLAK (VevoID,Fizeto,Szszam,Szkelt,Fizhat,
						 Tkelt,FizmodID,Netto,Brutto,CreUser,
						 TetelfejID,EloSzov,UtoSzov,KpVevonev,TombID,
						 SzlaHiv,DevizaID,DevizaErt,DevizaFiz,RiportosID,
						 Kedvezmeny,UzlKotoID,VevokpcsID,Arfolyam,BankID,
						 FejlecID,BankomID,RgzID,Kerekites,SzlaStatus,
						 TermekDij,TelepID,KeszPrgID,VerzioSzam,KulonAFA,
						 ArkategID,LogKtgSz)
				 VALUES (@vevoid,@fizeto,@szszam,@szkelt,@fizhat,
						 @tkelt,@fizmodid,@netto,@brutto,@creUser,
						 @tetelfejID,@Eloszov,@Utoszov,@KpVevonev,@tombid,
						 @szlahiv,@devizaid,@devizaert,@devizafiz,@riportosID,
						 @kedvezmeny,@uzlKotoID,@vevokpcsID,@arfolyam,@bankID,
						 @fejlecID,@bankomID,@rgznaploid,@kerekites,@szlaStatus,
						 @termekDij,@telepID,12,@verzioSzam,@kulonAFA,
						 @arkategID,@logKtgSz)

	SET @szamlaID=SCOPE_IDENTITY()

	IF @veg IS NOT NULL OR @eloleg IS NOT NULL
		INSERT INTO SZAMLAKV (SzamlaID, Veg, Meloleg) VALUES (@szamlaID, @veg, @eloleg)

    UPDATE TETELFEJ SET Bizszam=@szszam WHERE TetelfejID=@tetelfejID

	--kszlet korrekci
    SET @bizfejID=0
    SET @kellkeszlet=0

	IF RTRIM(dbo.fc_setup('R',@konyvev,112))='Igen'
		SET @kellkeszlet=1

	SET @szsorid=1
	WHILE @tetszam>=@szsorID
	BEGIN
		SET @beszAr = NULL
		SET @elfekvo = NULL

		SELECT @egysegar=egysegar,@mennyiseg=mennyiseg,@afaid=afaid,@szolgID=szolgid,@cikkid=cikkid,
			   @tipus=tipus,@afakulcs=afakulcs,@devizaar=devizaar,@raktarid=raktarid,@arajvsorID=arajvsorID,
			   @rendvsorID=rendvsorID,@bizsorID=bizsorID,@egyeb=egyeb,@maradek=maradek,@engedmeny=engedmeny,
			   @munkSzolID=munkSzolID,@polcSorok=polcSorok,@eSzamlaID=eSzamlaID,@pSztetelID=PSztetelID,@cikkSarzID=cikkSarzID
		FROM #szsor
		WHERE szsorID=@szsorID

		--van cikk s raktr
		IF @kellkeszlet=1 AND NOT @raktarid IS NULL AND NOT @cikkid IS NULL AND @cikkid>0 AND @raktarid>0
		BEGIN
			--bizonylatfej ltrehozs
			IF @bizfejID=0
			BEGIN

				SELECT @konyvev=EvekID FROM EVEK WHERE LEFT(Ev,4)=STR(YEAR(GETDATE()),4)

				--Szmla kszletmozgsnem bizonylat jele
				SELECT @mozgnemid=MozgnemID FROM MOZGNEM WHERE Bizjel=dbo.fc_setup('R',@konyvev,116) AND KonyvEv=@konyvev

				IF @mozgnemID IS NULL
				BEGIN
					IF @ujTranzakcio = 1
						ROLLBACK TRAN

					SELECT 0 AS rgznaplo,'' AS nev,0 AS hiba,'Nincs ilyen mozgsnem:'+dbo.fc_setup('R',@konyvev,116) AS hibaszov,'' AS szszam,0 AS szamlaID
					RETURN
                END

				INSERT INTO BIZFEJ (kelt,vevoid,eredeti,netto,brutto,
									mozgnemid,creuser,DevizaErt,Kedvezmeny,Statusz,
									UzlkotoID,Arfolyam,VevokpcsID,DevizaID)
							VALUES (GETDATE(),@vevoid,@szszam,@netto,@brutto,
									@mozgnemid,@creuser,@devizaert,@kedvezmeny,'S',
									@uzlKotoID,@arfolyam,@vevokpcsID,@devizaid)

                SET @bizfejID=SCOPE_IDENTITY()

				IF @bizfejID IS NULL OR @bizfejID=0
				BEGIN
					IF @ujTranzakcio = 1
						ROLLBACK TRAN

					SELECT 0 AS rgznaplo,'' AS nev,0 AS hiba,'Nem lehet bizfejet ltrehozni! ' AS hibaszov,'' AS szszam,0 AS szamlaID
					RETURN
				END
			END

			SELECT @keszl_afaid=AfaID,@beszAr=BeszAr,@meeIDC=MeID,@elfekvo=ISNULL(Rezsis,0) FROM CIKK WHERE CikkID=@cikkID
			SELECT @atlagar=AtlagAr FROM KESZLET WHERE CikkID=@cikkid AND RaktarID=@raktarid
		
			INSERT INTO BIZSOR (AfaID, RsorMeID, BizfejID, Rtipus, CikkID,
						Megjegyz, Mennyi, EgysegAr, KedvezS, RaktarID,
						DevizaAr, EladAr, Ertek, CreUser, CikkSarzID)
				VALUES (@keszl_afaid, @meeIDC, @bizfejID, @tipus, @cikkID,
						@egyeb, @mennyiseg, @atlagar, @engedmeny, @raktarid,
						@devizaar, @egysegar, ROUND(@mennyiseg*@atlagar,0), @creUser, @cikkSarzID)

			SELECT @tarhelyes=ISNULL(Tarhelyes,0) FROM RAKTAR WHERE RaktarID=@raktarid

			IF @tarhelyes=1
			BEGIN
				SET @keszletBizsorID=SCOPE_IDENTITY()

				IF LTRIM(RTRIM(ISNULL(@polcSorok, ''))) = ''
				BEGIN
					IF @ujTranzakcio = 1
						ROLLBACK TRAN

					SELECT 0 AS rgznaplo,'' AS nev,0 AS hiba,'Trhely kezels esetn ktelez a polc s a mennyisg megadsa' AS hibaszov,'' AS szszam,0 AS szamlaID
					RETURN
				END

				WHILE LEN(@polcSorok) > 0
				BEGIN
					SET @forrasRaktarPID=CONVERT(int, LEFT(@polcSorok,7))

					IF(RTRIM(LTRIM(SUBSTRING(@polcSorok,8,7))) <> '')
						SET @celRaktarPID=CONVERT(int, RTRIM(LTRIM(SUBSTRING(@polcSorok,8,7))))

					SET @pMennyi=CONVERT(numeric(10,3), RTRIM(LTRIM(SUBSTRING(@polcSorok,15,11))))

					SET @position=CHARINDEX('|',@polcSorok)

					IF @position>0   	
						SET @polcSorok = SUBSTRING(@polcSorok, @position+1, LEN(@polcSorok)-@position)
					ELSE
						SET @polcSorok=''

					IF OBJECT_ID('tempdb..#temp_bizsorp') IS NOT NULL
						DROP TABLE #temp_bizsorp;

					CREATE TABLE #temp_bizsorp (hiba int, hibaszov varchar(MAX))
					INSERT INTO #temp_bizsorp EXEC sp_bizsorp_insert @keszletBizsorID, @forrasRaktarPID, @celRaktarPID, @cikkID, @pMennyi, NULL, @creUser, NULL
					SELECT @hiba=hiba, @hibaszov=hibaszov FROM #temp_bizsorp
					DROP TABLE #temp_bizsorp

					IF @hiba < 0
					BEGIN
						IF @ujTranzakcio = 1
							ROLLBACK TRAN

						SELECT 0 AS rgznaplo,'' AS nev,@hiba AS hiba,@hibaszov AS hibaszov,'' AS szszam,0 AS szamlaID
						RETURN
					END
				END
			END
		END
		ELSE IF @cikkid IS NOT NULL AND @cikkid > 0 --BeszAr akkor is kell ha szlltlevbl szmlz (nincs raktarID)
			SELECT @beszAr=BeszAr, @elfekvo=ISNULL(Rezsis, 0) FROM CIKK WHERE CikkID=@cikkID
		ELSE IF @szolgID IS NOT NULL AND @szolgID > 0 --Szolgltats nkltsgi r
			SELECT @beszAr=ISNULL(OnkoltAr,0) FROM SZOLGAL WHERE SzolgID=@szolgID

		--Elleg levons
		IF @eSzamlaID IS NOT NULL
		BEGIN
			DECLARE @elolegLevon money, @elolegDevizaID tinyint

			SELECT @elolegDevizaID=DevizaID FROM SZAMLAK WHERE SzamlaID=@eSzamlaID

			IF @elolegDevizaID <> @devizaid
			BEGIN
				IF @ujTranzakcio = 1
					ROLLBACK TRAN

				SELECT 0 AS rgznaplo,'' AS nev,0 AS hiba,'A vgszmla s elleg szmla devizja eltr' AS hibaszov,'' AS szszam,0 AS szamlaID
				RETURN
			END

			IF @devizaid = 1
				SET @elolegLevon = ROUND(@egysegar * @mennyiseg * (1+(CAST(@afakulcs AS numeric)/CAST(100 AS numeric))),0)
			ELSE
				SET @elolegLevon = @devizaar * @mennyiseg * (1+(CAST(@afakulcs AS numeric)/CAST(100 AS numeric)))
			
			UPDATE SZAMLAKV SET MEloleg = MEloleg + @elolegLevon WHERE SzamlaID = @eSzamlaID
		END

		INSERT INTO SZTETEL (SzamlaID,EgysegAr,Mennyiseg,AfaID,Afakulcs,
							 SzolgID,CikkID,Tipus,DevizaAr,Egyeb,
							 RaktarID,Engedmeny,TetelSorsz,BeszAr,
							 OnktamogID,ESzamlaID)
					 VALUES (@szamlaID,@egysegar,@mennyiseg,@afaid,@afakulcs,
							 @szolgID,@CikkID,@tipus,@devizaAr,@egyeb,
							 @raktarid,@engedmeny,@szsorid,@beszAr,
							 @elfekvo,@eSzamlaID)

		SET @sztetelID=SCOPE_IDENTITY()

		SET @szsorid=@szsorid+1

		--rajnlatbl szmlzott
		IF (@arajvsorID IS NOT NULL)
		BEGIN
			--szmlattel bejegyzs
			UPDATE ARAJVSOR SET SztetelID = @sztetelID WHERE ArajVSorid = @arajvsorID

			IF (@maradek IS NOT NULL)
			BEGIN
				--eredeti sor
				SELECT @afaIDC=Afaid, @meeIDC=RsorMeid, @fejIDC=ArajVFejID, @megjegyzC=Megjegyz, @egysegarC=Egysegar, @kedvezmenyC=Kedvezs, @RaktarIDC=RaktarID FROM ARAJVSOR WHERE ArajVSorid = @arajvsorID

				--maradk sor felvitel (eredeti sorbl 2 sor)
			    INSERT INTO ARAJVSOR (Afaid, RsorMeid, ArajVFejID, Rtipus, CikkID,
                                      SzolgID, Megjegyz, Mennyi, Egysegar, Kedvezs,
                                      CreUser, RaktarID, TetelSorsz)
                              VALUES (@afaIDC, @meeIDC, @fejIDC, @tipus, @cikkID,
                                      @szolgID, @megjegyzC, @maradek, @egysegarC, @kedvezmenyC,
                                      @creUser, @RaktarIDC, (SELECT MAX(TetelSorsz) + 1 FROM ARAJVSOR WHERE ArajVFejID = @fejIDC))

                --eredeti mennyisg javtsa
                UPDATE ARAJVSOR SET Mennyi = @mennyiseg WHERE ArajVSorid = @arajvsorID
			END
		END
		--rendelsbl szmlzott
		ELSE IF (@rendvsorID IS NOT NULL)
		BEGIN
			--szmlattel bejegyzs
			UPDATE RENDVSOR SET SztetelID = @sztetelID WHERE RendvsorID = @rendvsorID

			IF (@maradek IS NOT NULL)
			BEGIN
				--eredeti sor
				SELECT @afaIDC=AfaID, @meeIDC=rsormeid, @fejIDC=RendvfejID, @megjegyzC=Megjegyz, @egysegarC=Egysegar, @kedvezmenyC=Kedvezs, @RaktarIDC=Raktid FROM RENDVSOR WHERE RendvsorID = @rendvsorID

				--maradk sor felvitel (eredeti sorbl 2 sor)
			    INSERT INTO RENDVSOR (AfaID, rsormeid, RendvfejID, Rtipus, CikkID,
                                      SzolgID, Megjegyz, Mennyi, Egysegar, Kedvezs,
                                      Raktid, CreUser, TetelSorsz)
                              VALUES (@afaIDC, @meeIDC, @fejIDC, @tipus, @cikkID,
                                      @szolgID, @megjegyzC, @maradek, @egysegarC, @kedvezmenyC,
                                      @RaktarIDC, @creUser, (SELECT MAX(TetelSorsz) + 1 FROM RENDVSOR WHERE RendvfejID = @fejIDC))

				--eredeti mennyisg javtsa
				UPDATE RENDVSOR SET Mennyi = @mennyiseg WHERE RendvsorID = @rendvsorID
			END
		END
		--szlltlevlbl szmlzott
		ELSE IF (@bizsorID IS NOT NULL)
		BEGIN
			--szmlattel bejegyzs
			UPDATE BIZSOR SET SztetelID = @sztetelID WHERE BizsorID = @bizsorID

			IF (@maradek IS NOT NULL)
			BEGIN
				--eredeti sor
				SELECT @afaIDC=AfaID, @meeIDC=RsorMeID, @fejIDC=BizfejID, @megjegyzC=Megjegyz, @egysegarC=EgysegAr, @kedvezmenyC=KedvezS, @RaktarIDC=RaktarID, @devizaArC=DevizaAr, @eladArC=EladAr, @ertekC=Ertek FROM BIZSOR WHERE BizsorID = @bizsorID

				SET @bizsorUjErtek = @egysegarC * @mennyiseg;

				--maradk sor felvitel (eredeti sorbl 2 sor)
				INSERT INTO BIZSOR (AfaID, RsorMeID, BizfejID, Rtipus, CikkID,
									SzolgID, Megjegyz, Mennyi, EgysegAr, KedvezS,
									RaktarID, DevizaAr, EladAr, Ertek, CreUser)
							VALUES (@afaIDC, @meeIDC, @fejIDC, @tipus, @cikkID,
									@szolgID, @megjegyzC, @maradek, @egysegarC,	@kedvezmenyC,
									@RaktarIDC, @devizaArC, @eladArC, @ertekC - @bizsorUjErtek, @creUser)

				SET @maradekBizsorID=SCOPE_IDENTITY()

				--eredeti mennyisg javtsa
				UPDATE BIZSOR SET Mennyi = @mennyiseg, Ertek = @bizsorUjErtek WHERE BizsorID = @bizsorID

				SELECT @keszletPID=KeszletpID FROM BIZSORP WHERE BizsorID = @bizsorID

				IF @keszletPID IS NOT NULL
				BEGIN
					--trhely maradk sor felvitel (eredeti sorbl 2 sor)
					INSERT INTO BIZSORP (BizsorID, PMennyi, KeszletpID, CreUser) VALUES (@maradekBizsorID, @maradek, @keszletPID, @creuser)

					--trhely eredeti mennyisg javtsa
					UPDATE BIZSORP SET PMennyi = @mennyiseg WHERE BizsorID = @bizsorID
				END
			END
		END
		--munkalap szolgltatsbl szmlzott
		ELSE IF (@munkSzolID IS NOT NULL)
		BEGIN
			--szmlattel bejegyzs
			UPDATE MUNKSZOL SET SztetelID = @sztetelID WHERE MunkSzolID = @munkSzolID

			IF (@maradek IS NOT NULL)
			BEGIN
				--eredeti sor
				SELECT  @fejIDC=MunkalapID, @egysegarC=EgysegAr, @afaIDC=AfaID, @megjegyzC=Megjegyzes FROM MUNKSZOL WHERE MunkSzolID = @munkSzolID

				--maradk sor felvitel (eredeti sorbl 2 sor)
				INSERT INTO MUNKSZOL (MunkalapID, SzolgID, Mennyi, Egysegar, AfaID,
										CreUser, Megjegyzes)
								VALUES (@fejIDC, @szolgID, @maradek, @egysegarC, @afaIDC, 
										@creUser, @megjegyzC)

				--eredeti mennyisg javtsa
				UPDATE MUNKSZOL SET Mennyi = @mennyiseg WHERE MunkSzolID = @munkSzolID
			END
		END

		--proforma szmlbl szmlzott
		IF (@pSztetelID IS NOT NULL)
		BEGIN
			--szmlattel bejegyzs
			UPDATE PSZTETEL SET SztetelID = @sztetelID WHERE PsztetelID = @pSztetelID

			IF (@maradek IS NOT NULL)
			BEGIN
				--eredeti sor
				SELECT @fejIDC=PszamlaID, @afaIDC=AfaID, @afakulcsC=Afakulcs, @megjegyzC=Egyeb, @egysegarC=EgysegAr, @kedvezmenyC=Engedmeny, @RaktarIDC=RaktarID FROM PSZTETEL WHERE PsztetelID = @pSztetelID

				--maradk sor felvitel (eredeti sorbl 2 sor)
			    INSERT INTO PSZTETEL (PszamlaID, AfaID, Afakulcs, Tipus, CikkID,
                                      SzolgID, Egyeb, Mennyiseg, EgysegAr, Engedmeny,
                                      RaktarID)
                              VALUES (@fejIDC, @afaIDC, @afakulcsC, @tipus, @cikkID,
									  @szolgID, @megjegyzC, @maradek, @egysegarC, @kedvezmenyC,
                                      @RaktarIDC)

				--eredeti mennyisg javtsa
				UPDATE PSZTETEL SET Mennyiseg = @mennyiseg WHERE PsztetelID = @pSztetelID
			END
		END
	END

	--kontrozs
	SET @szsorID=1
	WHILE @konttet>=@szsorID
	BEGIN
		SELECT @szszID=szszID,@eszszID=eszszID,@aszszID=aszszID,@osszeg=osszeg,@afaosszeg=afaosszeg,
			   @bizszov=bizszov,@afaid=afaid,@jogcimid=jogcimid,@devizaban=devizaban,@uzemekid=uzemekid
		FROM #kont
		WHERE kontID=@szsorID

		SELECT @irany=irany FROM JOGCIM WHERE JogcimID=@jogcimid
		IF @irany='C'
			SET @tkjel='False'
		ELSE
			SET @tkjel='True'

		INSERT INTO TETELSOR (TetelfejID,VevoID,SzamlaID,SzszID,EszszID,
							  AszszID,Osszeg,TKjel,Tartozik,AfaOsszeg,
							  Kvjel,Sorszam,Bizszov,AfaID,FizmodID,
							  JogcimID,Bkelt,UzemekID)
					  VALUES (@tetelfejID,@fizeto,@szamlaid,@szszID,@eszszID,
							  @aszszID,@devizaban,@tkjel,@osszeg+@afaosszeg,@afaosszeg,
							  'A',@szsorID,@bizszov,@afaid,@fizmodid,
							  @jogcimID,@tkelt,@uzemekid)

		SET @szsorid=@szsorid+1
	END

	--proforma szmlbl szmlzott elleg szmla
	IF @pszamlaID IS NOT NULL
		UPDATE PSZAMLAK SET SzamlaID = @szamlaID, Statusz = 'E' WHERE PszamlaID = @pszamlaID

	--Helyesbt szmla ksztsekor, az eredeti szmla Mdostott sttusz
	IF @szlaStatus='H'
		UPDATE SZAMLAK SET SzlaStatus='M' WHERE Szszam=@szlahiv

	IF @ujTranzakcio = 1
		COMMIT

    SELECT @rgznaploid AS rgznaplo,@rgzneve AS nev,0 AS hiba,'OK' AS hibaszov,@szszam AS szszam,@szamlaID AS szamlaID

END TRY
BEGIN CATCH
	IF @ujTranzakcio = 1
		ROLLBACK TRAN

	SELECT 0 AS rgznaplo,'' AS nev,Error_number() AS hiba,Error_message() AS hibaszov,'' AS szszam,0 AS szamlaID
	RETURN
END CATCH
END