CREATE TRIGGER [dbo].[tr_arajvfej_insert] ON [dbo].[ARAJVFEJ] 
FOR INSERT 
AS

DECLARE @arajvfejID int, @userID smallint, @telepID tinyint, @arajvJel varchar(3), @arajvSorsz int, @arajvHossz tinyint, @evJel varchar(2)

BEGIN TRY
	SELECT @arajvfejID = ArajvfejID, @userID = CreUser FROM inserted

	SET @telepID = dbo.fc_usetup(107, @userID)
	
	IF @telepID IS NULL OR @telepID = 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN
	END

	SELECT @arajvJel = ArajVJel, @arajvSorsz = ISNULL(ArajVSorsz, 0), @arajvHossz = ArajVHossz, @evJel = EvJel FROM TELEP WHERE TelepID = @telepID

	UPDATE ARAJVFEJ SET ArajSzam = LTRIM(RTRIM(@arajvJel)) + '-' + @evJel + '-' + REPLACE(STR(@arajvSorsz + 1, @arajvHossz), SPACE(1), '0') WHERE Arajvfejid = @arajvfejID

	UPDATE TELEP SET ArajVSorsz = @arajvSorsz + 1 WHERE TelepID = @telepID
END TRY
BEGIN CATCH
	ROLLBACK TRANSACTION
END CATCH