CREATE TRIGGER [dbo].[tr_cikk_modify2] ON [dbo].[CIKK] FOR UPDATE
AS

DECLARE @userID smallint

--Digitlis cmke user azonost
SELECT @userID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 228

IF @userID = ''
	RETURN

DECLARE @vonalkodID int, @cikkID int, @cikkNev varchar(50), @cikkTipus varchar(50), @cEgysAr1B money, @meID tinyint, @me2 tinyint, @voszto numeric (9,4),

		@dCikkNev varchar(50), @dCikkTipus varchar(50), @dCEgysAr1B money, @dMeID tinyint, @dMe2 tinyint, @dVoszto numeric (9,4),

		@gcmMuvInt int

	SELECT @cikkID=CikkID, @cikkNev=CikkNev, @cikkTipus=CikkTipus, @cEgysAr1B=CEgysAr1B, @meID=MeID, @me2=Me2, @voszto=Voszto FROM inserted

	SELECT @dCikkNev=CikkNev, @dCikkTipus=CikkTipus, @dCEgysAr1B=CEgysAr1B, @dMeID=MeID, @dMe2=Me2, @dVoszto=Voszto FROM deleted

	--Ha nem vltozott az tadott rtkek valamelyike
	IF @cikkNev = @dCikkNev AND ISNULL(@cikkTipus,'') = ISNULL(@dCikkTipus,'') AND @cEgysAr1B = @dCEgysAr1B AND @meID = @dMeID AND ISNULL(@me2,0) = ISNULL(@dMe2,0) AND ISNULL(@voszto,0) = ISNULL(@dVoszto,0)
		RETURN

DECLARE VonalkodCursor CURSOR FOR

	SELECT VONALKOD.VonalkodID
	FROM VONALKOD
		 INNER JOIN CIKK ON CIKK.CikkID = VONALKOD.CikkID
	WHERE Cikk.CikkID = @cikkID

OPEN VonalkodCursor

FETCH NEXT FROM VonalkodCursor INTO @vonalkodID

WHILE @@FETCH_STATUS = 0
BEGIN
	SET @gcmMuvInt = 32 --Cikk letlts

	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@vonalkodID,@userID)

	FETCH NEXT FROM VonalkodCursor INTO @vonalkodID
END

CLOSE VonalkodCursor
DEALLOCATE VonalkodCursor