CREATE TRIGGER [dbo].[tr_cikkacsf_modify] ON [dbo].[CIKKACSF] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @cikkacsfID smallint, @cikkacsfnv varchar(50), @cikkHierID smallint,

		@dCikkacsfID smallint, @dCikkacsfnv varchar(50), @dCikkHierID smallint,

		@gcmMuvInt int

SELECT @cikkacsfID=CikkacsfID, @cikkacsfnv=Cikkacsfnv, @cikkHierID=CikkHierID FROM inserted

SELECT @dCikkacsfID=CikkacsfID, @dCikkacsfnv=Cikkacsfnv, @dCikkHierID=CikkHierID FROM deleted

--j vagy mdosts
IF @cikkacsfID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 76 --ltalnos cikkcsoport letlts

	--Mdosts
	IF @dCikkacsfID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @cikkacsfnv = @dCikkacsfnv AND @cikkHierID = @dCikkHierID
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 77 --ltalnos cikkcsoport trls
	SET @cikkacsfID = @dCikkacsfID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkacsfID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 76)
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkacsfID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkacsfID,@webUserID2)