CREATE TRIGGER [dbo].[tr_cikkacsx_modify] ON [dbo].[CIKKACSX] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @cikkAcsxID int, @ertek varchar(500),

		@dCikkAcsxID int, @dErtek varchar(500),

		@gcmMuvInt int

SELECT @cikkAcsxID=CikkconsID, @ertek=Ertek FROM inserted

SELECT @dCikkAcsxID=CikkconsID, @dErtek=Ertek FROM deleted

--j vagy mdosts
IF @cikkAcsxID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 84 --ltalnos cikkcsoport lers letlts

	--Mdosts
	IF @dCikkAcsxID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @ertek = @dErtek
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 85 --ltalnos cikkcsoport lers trls
	SET @cikkAcsxID = @dCikkAcsxID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkAcsxID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 84) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkAcsxID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 84) AND UserID = @webUserID2
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkAcsxID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkAcsxID,@webUserID2)