CREATE TRIGGER [dbo].[tr_cikkcsop_modify] ON [dbo].[CIKKCSOP] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @cikkCsopID smallint, @csopNev varchar(50),

		@dCikkCsopID smallint, @dCsopNev varchar(50),

		@gcmMuvInt int

SELECT @cikkCsopID=Cikkcsopid, @csopNev=Csopnev FROM inserted

SELECT @dCikkCsopID=Cikkcsopid, @dCsopNev=Csopnev FROM deleted

--j vagy mdosts
IF @cikkCsopID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 36 --Cikk csoport letlts

	--Mdosts
	IF @dCikkCsopID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @csopNev = @dCsopNev
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 37 --Cikk csoport trls
	SET @cikkCsopID = @dCikkCsopID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkCsopID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 36) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkCsopID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 36) AND UserID = @webUserID2
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkCsopID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkCsopID,@webUserID2)