CREATE TRIGGER [dbo].[tr_cikkhely_modify] ON [dbo].[CIKKHELY] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @cikkHelyID int, @cikkHelyNv varchar(60),

		@dCikkHelyID int, @dCikkHelyNv varchar(60),

		@gcmMuvInt int

SELECT @cikkHelyID=CikkHelyID, @cikkHelyNv=CikkHelyNv FROM inserted

SELECT @dCikkHelyID=CikkHelyID, @dCikkHelyNv=CikkHelyNv FROM deleted

--j vagy mdosts
IF @cikkHelyID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 52 --Cikk helyettest letlts

	--Mdosts
	IF @dCikkHelyID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @cikkHelyNv = @dCikkHelyNv
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 53 --Cikk helyettest trls
	SET @cikkHelyID = @dCikkHelyID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkHelyID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 52) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkHelyID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 52) AND UserID = @webUserID2
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkHelyID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkHelyID,@webUserID2)