
create TRIGGER [dbo].[tr_munkszol_insert] ON [dbo].[munkszol] 
FOR insert,update,delete
AS

declare @munkalapID int,@tmennyi numeric (11,3),@szemelyID int,@kelt date,@creuser smallint,@rezsiktg money,@munkszemid int,@munkszolid int,@rezsiora money,@ktgAlvalal money
declare @dmunkalapID int,@dtmennyi numeric (11,3),@dszemelyID int,@dcreuser smallint
SET NOCOUNT ON;
select @munkalapID=munkalapID,@szemelyID=szemelyID,@tmennyi=tmennyi,@creuser=creuser from inserted 
select @dmunkalapID=munkalapID,@dszemelyID=szemelyID,@dtmennyi=tmennyi,@dcreuser=creuser from deleted 
 if @munkalapid is null
    set @munkalapid=@dmunkalapid


if @szemelyid is not null or @dszemelyid is not null
begin
 if @szemelyid is null
   set @szemelyid=@dszemelyid
 if @creuser is null
   set @creuser=@dcreuser

if CURSOR_STATUS('global','mszol')>=-1
       deallocate mszol
declare mszol cursor for
 select szemely.szemelyid,kelt,isnull(sum(tmennyi),0) as tmennyi,isnull(avg(szemely.rezsiorabr),0) as rezsiorabr from munkszol 
   left join szemely on szemely.szemelyid=munkszol.szemelyid where munkalapid=@munkalapid group by szemely.szemelyid,kelt
open mszol 
fetch mszol into @szemelyid,@kelt,@tmennyi,@rezsiora
 while @@fetch_status=0
  begin
    select @munkszemid=munkszemID,@dtmennyi=ora from munkszem where munkalapid=@munkalapid and szemelyid=@szemelyid and kelt=@kelt 
    if @@ROWCOUNT=0
            insert into munkszem (szemelyid,munkalapid,kelt,ora,rezsiktg,creuser) values (@szemelyid,@munkalapid,@kelt,@tmennyi,@tmennyi*@rezsiora,@creuser)
    else
           update munkszem set ora=@tmennyi,rezsiktg=@tmennyi*@rezsiora where munkszemid=@munkszemid    
     fetch mszol into @szemelyid,@kelt,@tmennyi,@rezsiora
  end
  close mszol
deallocate mszol

if CURSOR_STATUS('global','mszem')>=-1
       deallocate mszem
declare mszem cursor for
select munkszemid,szemelyid,kelt from munkszem where munkalapid=@munkalapid
open mszem
fetch mszem into @munkszemid,@szemelyid,@kelt
  while @@fetch_status=0
    begin     
     select @munkszolid=munkszolid from munkszol where munkalapid=@munkalapid and szemelyid=@szemelyid and kelt=@kelt
     if @@ROWCOUNT=0
        delete from munkszem where munkszemid=@munkszemid
  fetch mszem into @munkszemid,@szemelyid,@kelt
end
close mszem
deallocate mszem

end

select @ktgAlvalal=isnull(sum(mennyi*egysegar),0) from munkszol where munkalapid=@munkalapid and szemelyid is null 
update munklap set KtgAlvalal=@KtgAlvalal where  munkalapid=@munkalapid

