CREATE TRIGGER [dbo].[tr_olvascsm_update] ON [dbo].[OLVASCSM]
FOR UPDATE
AS 
BEGIN
BEGIN TRY
	DECLARE @csomagID int, 
	@psionbol smalldatetime,
	@dPsionbol smalldatetime
	
	SELECT @csomagID = CsomagID, @psionbol = Psionbol FROM inserted
	SELECT @dPsionbol = Psionbol FROM deleted

	--lezrs
	IF @psionbol IS NOT NULL AND @dPsionbol IS NULL
	BEGIN
		BEGIN TRY

			BEGIN TRAN

			--GCM Sync tblbl trls
			DELETE FROM GCMSYNCU WHERE GCMSyncID IN (SELECT GCMSyncID FROM GCMSYNC WHERE CsomagID = @csomagID)
			DELETE FROM GCMSYNC WHERE CsomagID = @csomagID

			COMMIT

		END TRY
		BEGIN CATCH
			ROLLBACK
		END CATCH
	END
END TRY
BEGIN CATCH
END CATCH
END