CREATE TRIGGER [dbo].[tr_pervegre_insert] ON [dbo].[PERVEGRE]
AFTER INSERT, UPDATE
AS 
BEGIN
	DECLARE @peresfID int

	SET NOCOUNT ON

	SELECT @peresfID = PeresfID FROM inserted

	UPDATE PERESF SET TovVegre = (SELECT MIN(TovVegre) FROM PERVEGRE WHERE PeresfID = @peresfID) WHERE peresfID = @peresfID
END