CREATE TRIGGER [dbo].[tr_programs_update] ON [dbo].[PROGRAMS]
FOR UPDATE
AS 
BEGIN
BEGIN TRY
	DECLARE @prgID tinyint, @prgVersion varchar(12), @prgTime smalldatetime, @dPrgVersion varchar(12), @token varchar(4096), @command varchar(8000), @proxyAcc varchar(50), @toolsPath varchar(200)

	SELECT @prgID = Prgid, @prgVersion = PrgVersion, @prgTime = Prgtime FROM inserted
	SELECT @dPrgVersion = PrgVersion FROM deleted

	--Nem kristly app vagy nem vltozott a verziszm
	IF DB_NAME() LIKE '%teszt%' OR @prgID <> 13 OR @prgVersion = @dPrgVersion
		RETURN

	SELECT TOP 1 @proxyAcc = LTRIM(RTRIM(ProxyAcc)), @toolsPath = LTRIM(RTRIM(ToolsPath)) FROM CEG ORDER BY CegID
		
	IF(@proxyAcc IS NULL OR @proxyAcc = '')
	BEGIN
		SELECT -1 AS hiba, 'Nincs megadva a cg trzsben a Proxy Account' AS hibaszov
		RETURN
	END

	IF @toolsPath IS NULL
		RETURN

	IF RIGHT(@toolsPath,1) <> '\'
		SET @toolsPath = @toolsPath + '\'

	IF CURSOR_STATUS('global','GcmUserCursor')>=-1
	BEGIN
		CLOSE GcmUserCursor
		DEALLOCATE GcmUserCursor
	END

	DECLARE GcmUserCursor CURSOR FOR

	SELECT DISTINCT TOKEN
	FROM GCMUSER
	WHERE StepInTime IS NOT NULL AND StepOuTime IS NULL

	OPEN GcmUserCursor

	EXECUTE AS USER = @proxyAcc

	FETCH NEXT FROM GcmUserCursor INTO @token
	WHILE @@FETCH_STATUS = 0
	BEGIN
		SELECT @command = @toolsPath+'GCMSender\GCMSender.exe -apiKey:"AIzaSyC9PI42YCSuG0ERcQl9aDfJKdjq4xUp_FQ" -to:"'+@token+'" -data:"{ \"Muvelet\" : \"Programfrissites\", \"ProgramVerzio\" : \"'+@prgVersion+'\",\"ProgramIdo\" : \"'+REPLACE(CONVERT(varchar, @prgTime, 20),'-','.')+'\" }"'
		EXEC xp_cmdshell @command, NO_OUTPUT

		FETCH NEXT FROM GcmUserCursor INTO @token
	END

	REVERT

	CLOSE GcmUserCursor
	DEALLOCATE GcmUserCursor

END TRY
BEGIN CATCH
END CATCH
END