CREATE TRIGGER [dbo].[tr_rendsfej_update] ON [dbo].[RENDSFEJ] 
FOR UPDATE
AS

DECLARE @rendsfejID int, @statusz char(1), @dStatusz char(1), @cikkID int, @raktarID tinyint, @rendelt numeric(10,3), @keszletID int

SELECT @rendsfejID = RendsfejID, @statusz = Statusz FROM inserted
SELECT @dStatusz = Statusz FROM deleted

--Trlt sttusz
IF @statusz = 'T' AND @dStatusz <> 'T'
BEGIN

	IF CURSOR_STATUS('global','RendssorCursor')>=-1
	BEGIN
		CLOSE RendssorCursor
		DEALLOCATE RendssorCursor
	END

	DECLARE RendssorCursor CURSOR FOR

	SELECT CikkID, Raktid
	FROM RENDSSOR
	WHERE RendsfejID = @rendsfejID AND CikkID > 0 AND Raktid > 0

	OPEN RendssorCursor

	FETCH NEXT FROM RendssorCursor INTO @cikkID, @raktarID
	WHILE @@FETCH_STATUS = 0
	BEGIN

		SELECT @rendelt=ISNULL(SUM(RENDSSOR.Mennyi),0)
		FROM RENDSSOR
			 INNER JOIN RENDSFEJ ON RENDSFEJ.RendsfejID = RENDSSOR.RendsfejID
		WHERE RENDSFEJ.Statusz <> 'T' AND RENDSFEJ.Statusz <> 'S' AND RENDSSOR.CikkID = @cikkID AND RENDSSOR.Raktid = @raktarID AND RENDSSOR.BizsorID IS NULL

		SELECT @keszletID=KeszletID FROM KESZLET WHERE CikkID=@cikkID AND RaktarID=@raktarID

		IF @keszletID IS NULL
			INSERT INTO KESZLET (CikkID,RaktarID,Rendelt) VALUES (@cikkID,@raktarID,@rendelt)
		ELSE
			UPDATE KESZLET SET Rendelt=@rendelt WHERE CikkID=@cikkID AND RaktarID=@raktarID

		FETCH NEXT FROM RendssorCursor INTO @cikkID, @raktarID
	END

	CLOSE RendssorCursor
	DEALLOCATE RendssorCursor

END