CREATE TRIGGER [dbo].[tr_rendssor_delete] ON [dbo].[RENDSSOR] 
FOR DELETE
AS

DECLARE @rendsfejID int, @netto money, @tetelszam smallint,@afa money, @kedvezF numeric (5,2), @cikkID int, @rendelt numeric(10,2), @raktarID tinyint, @keszletID int, @szlaRound tinyint

SELECT @rendsfejID=rendsfejID, @cikkID=CikkID, @raktarID=Raktid FROM deleted

SELECT @kedvezf=RENDSFEJ.Kedvezf, @szlaRound=DEVIZA.SzlaRound
FROM RENDSFEJ
     INNER JOIN DEVIZA ON RENDSFEJ.devizaid = DEVIZA.DevizaID
WHERE RENDSFEJ.RendsfejID=@rendsfejID

SELECT @netto=SUM(ISNULL(RENDSSOR.Egysegar,0) * RENDSSOR.Mennyi), 
       @afa=SUM(ISNULL(RENDSSOR.Egysegar,0) * RENDSSOR.Mennyi * (AFAK.Szaz/100)),
       @tetelszam=COUNT(RENDSSOR.RendsfejID)
FROM RENDSSOR
     LEFT JOIN AFAK ON RENDSSOR.Afaid=AFAK.AfaID WHERE RENDSSOR.RendSfejID=@rendsfejID

SET @kedvezF=ISNULL(@kedvezF,0)
SET @netto=ISNULL(@netto,0)
SET @afa=ISNULL(@afa,0)
SET @tetelszam=ISNULL(@tetelszam,0)

SET @netto=ROUND(@netto * (100-@kedvezF)/100, @szlaRound)
SET @afa=ROUND(@afa * (100-@kedvezF)/100, @szlaRound)

UPDATE RENDSFEJ SET Netto=@netto, Tetelszam=@tetelszam, Brutto=@netto + @afa WHERE RendsfejID=@rendsfejID

--kszlet
IF @cikkID IS NOT NULL AND @raktarID IS NOT NULL
BEGIN
    SELECT @rendelt=ISNULL(SUM(RENDSSOR.Mennyi),0)
    FROM RENDSSOR
         INNER JOIN RENDSFEJ ON RENDSFEJ.RendsfejID = RENDSSOR.RendsfejID
    WHERE RENDSFEJ.Statusz <> 'T' AND RENDSFEJ.Statusz <> 'S' AND RENDSSOR.CikkID = @cikkID AND RENDSSOR.Raktid = @raktarID AND RENDSSOR.BizsorID IS NULL

    SELECT @keszletID=KeszletID FROM KESZLET WHERE CikkID=@cikkID AND RaktarID=@raktarID

    IF @keszletID IS NULL
        INSERT INTO KESZLET (CikkID,RaktarID,Rendelt) VALUES (@cikkID,@raktarID,@rendelt)
    ELSE
        UPDATE KESZLET SET Rendelt=@rendelt WHERE CikkID=@cikkID AND RaktarID=@raktarID
END