CREATE TRIGGER [dbo].[tr_szallito_modify] ON [dbo].[SZALLITO] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @szallitoID smallint, @szneve varchar(40), @megszunt bit,

		@dSzallitoID smallint, @dSzneve varchar(40), @dMegszunt bit,

		@gcmMuvInt int

SELECT @szallitoID=SzallitoID, @szneve=Szneve, @megszunt=ISNULL(MegszuntCg,0) FROM inserted

SELECT @dSzallitoID=SzallitoID, @dSzneve=Szneve, @dMegszunt=ISNULL(MegszuntCg,0) FROM deleted

--Trls vagy (mdosts s megszntt teszi)
IF (@szallitoID IS NULL AND @dSzallitoID IS NOT NULL) OR (@szallitoID IS NOT NULL AND @dSzallitoID IS NOT NULL AND @dMegszunt = 0 AND @megszunt = 1)
BEGIN
	--Megsznt szllt trlst nem kell kikldeni
	IF @dMegszunt = 1
		RETURN

	SET @gcmMuvInt = 65 --Szllt trls
	SET @szallitoID = @dSzallitoID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @szallitoID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 64) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @szallitoID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 64) AND UserID = @webUserID2
END
--j vagy mdosts
ELSE
BEGIN
	SET @gcmMuvInt = 64 --Szllt letlts

	--Mdosts
	IF @dSzallitoID IS NOT NULL
	BEGIN

		--Megsznt szllt mdostst nem kell kikldeni
		IF @megszunt = 1
			RETURN

		--Ha nem vltozott az tadott rtkek valamelyike
		IF @szneve = @dSzneve AND @megszunt = @dMegszunt
			RETURN

	END
	--j
	ELSE
	BEGIN
		--Megsznt szllt rgztst nem kell kikldeni
		IF @megszunt = 1
			RETURN
	END
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@szallitoID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@szallitoID,@webUserID2)