CREATE TRIGGER [dbo].[tr_vevoreg_update] ON [dbo].[VEVOREG] FOR UPDATE
AS

--Ha a Kristly kezeli az E-gyfl interfsz adatbzist
IF (SELECT COUNT(*) FROM CEG WHERE ISNULL(EugyServer,'') <> '' AND ISNULL(EugyDB,'') <> '' AND ISNULL(EugyUser,'') <> '' AND ISNULL(EugyPass,'') <> '') > 0
	RETURN

DECLARE @webUserID smallint, @statusz char, @dStatusz char, @vevoRegID int

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

IF @webUserID = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

SELECT @vevoRegID=VevoregID, @statusz=Statusz FROM inserted

SELECT @dStatusz=Statusz FROM deleted

--Ha regisztrcibl deaktivls
IF @dStatusz = 'R' AND @statusz = 'D'
BEGIN
	--Webshop vev deaktivls
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 67),@vevoRegID,@webUserID)
END