CREATE TRIGGER [dbo].[tr_webarak_modify] ON [dbo].[WEBARAK] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod IN('FLEX')) = 0
	RETURN

DECLARE @webarakID int, @cikkID int, @wEgysar money, @wEgysarB money, @megszunt bit, @cikkhiercs smallint, @webre bit, @webre2 bit,

		@dWebarakID int, @dCikkID int, @dWEgysar money, @dWEgysarB money, @dMegszunt bit, @dCikkhiercs smallint, @dWebre bit, @dWebre2 bit

SELECT @webarakID=inserted.WebarakID, @cikkID=CIKK.CikkID, @wEgysar=inserted.WEgysar, @wEgysarB=inserted.WEgysarB,
	   @megszunt=ISNULL(CIKK.Megszunt,0), @cikkhiercs=CIKK.Cikkhiercs, @webre=ISNULL(CIKK.Webre,0), @webre2=ISNULL(CIKK.Webre2,0)
FROM inserted
	 INNER JOIN CIKK ON CIKK.CikkID = inserted.CikkID

SELECT @dWebarakID=deleted.WebarakID, @dCikkID=CIKK.CikkID, @dWEgysar=deleted.WEgysar, @dWEgysarB=deleted.WEgysarB,
	   @dMegszunt=ISNULL(CIKK.Megszunt,0), @dCikkhiercs=CIKK.Cikkhiercs, @dWebre=ISNULL(CIKK.Webre,0), @dWebre2=ISNULL(CIKK.Webre2,0)
FROM deleted
	 INNER JOIN CIKK ON CIKK.CikkID = deleted.CikkID

--j vagy mdosts
IF @webarakID IS NOT NULL
BEGIN

	--Mdosts
	IF @dWebarakID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @cikkID = @dCikkID AND @wEgysar = @dWEgysar AND @wEgysarB = @dWEgysarB
			RETURN

		--ha megvltozott a cikk, az eredeti cikk jboli letltse
		IF @cikkID <> @dCikkID
		BEGIN
			IF @dMegszunt = 0 AND @dCikkhiercs IS NOT NULL
			BEGIN
				IF @webUserID <> '' AND @dWebre = 1
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32),@dCikkID,@webUserID)

				IF @webUserID2 <> '' AND @dWebre2 = 1
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32),@dCikkID,@webUserID2)
			END
		END
	END

	IF @megszunt = 1 OR @cikkhiercs IS NULL OR (@webre = 0 AND @webre2 = 0)
		RETURN
END
ELSE
BEGIN
	--Nem aktulis
	IF @dMegszunt = 1 OR @dCikkhiercs IS NULL OR (@dWebre = 0 AND @dWebre2 = 0)
		RETURN

	SET @cikkID = @dCikkID
	SET @webre = @dWebre
	SET @webre2 = @dWebre2
END

IF @webre = 1 AND @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32),@cikkID,@webUserID)

IF @webre2 = 1 AND @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32),@cikkID,@webUserID2)